/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Implementacion de AnalisisPersona.h
		Clase identifica donde est un cuerpo humano dentro de la escena e identifica sus partes
*/
#include "AnalisisPersona.h"

AnalisisPersona::AnalisisPersona(void)
{
	opciones = OpcionesNegocio::getOpcionesNegocio();
	CvSize tam =opciones->getTamImagen();
	image = cvCreateImage( tam, 8, 3 );
	imgRetorno = cvCreateImage( tam, 8, 3 );
	imgGray = cvCreateImage( tam, 8, 1 );
	imgGrayTemp = cvCreateImage( tam, 8, 1 );
	//filtro=f;
	//fo=foIn;

	caso = -1;
	casoPrev=-1;
	casoPrev2=-1;

	suelo =cvRect(-1,-1,-1,-1);
}


AnalisisPersona::~AnalisisPersona(void)
{
}

IplImage* AnalisisPersona::execute(IplImage*frame, int frameActual)
{
//	if(frameActual<2 || HistoricoEsqueletos::getHistoricoEsqueletos()->size()==0 || HistoricoEsqueletos::getHistoricoEsqueletos()->back().actualizado!=0){//situacion de arranque, sin informacion previa del esqueleto
		int i;
		double t = 0;
		t = (double)cvGetTickCount();

		cvCopy(frame, imgRetorno, 0);
		if(frame->nChannels==1){
			cvCopy(frame, imgGray, 0);
		}else{
			cvCvtColor( frame, imgGray, CV_RGB2GRAY );
		}
		//cvCvtColor( image, imgGray, CV_BGR2GRAY );
		
		hallarProyecciones();//calcula las proyecciones del cuerpo y lo localiza dentro de la imagen
		
		
		//impresion de algunos datos utiles en la imagen
	//for(i=0;i<persona.PVC[0].er.maxRel.size();i++){
	//	cvCircle( imgRetorno, persona.PVC[0].puntos[persona.PVC[0].er.maxRel[i]], 3, CV_RGB(255,0,0), -1, 8,0);
	//}
	//for(i=0;i<persona.PVC[0].er.minRel.size();i++){
	//	cvCircle( imgRetorno, persona.PVC[0].puntos[persona.PVC[0].er.minRel[i]], 3, CV_RGB(125,0,0), -1, 8,0);
	//}
	for(i=0;i<persona.PHD[0].er.maxRel.size();i++){
		cvCircle( imgRetorno, persona.PHD[0].puntos[persona.PHD[0].er.maxRel[i]], 3, CV_RGB(255,0,0), -1, 8,0);
	}
	for(i=0;i<persona.PHD[0].er.minRel.size();i++){
		cvCircle( imgRetorno, persona.PHD[0].puntos[persona.PHD[0].er.minRel[i]], 3, CV_RGB(125,0,0), -1, 8,0);
	}
	//for(i=0;i<persona.PHI[0].er.maxRel.size();i++){
	//	cvCircle( imgRetorno, persona.PHI[0].puntos[persona.PHI[0].er.maxRel[i]], 3, CV_RGB(0,255,0), -1, 8,0);
	//}
	//for(i=0;i<persona.PHI[0].er.minRel.size();i++){
	//	cvCircle( imgRetorno, persona.PHI[0].puntos[persona.PHI[0].er.minRel[i]], 3, CV_RGB(0,125,0), -1, 8,0);
	//}
	//impresion de estadisticas basicas de los filtros de compas
	cout << "PVC: " << persona.PVC[0].er.maxRel.size() << ". "; 
	cout << "PHD: " << persona.PHD[0].er.maxRel.size() << ". "; 
	cout << "PHI: " << persona.PHI[0].er.minRel.size() << ". "; 
	



		caso=MotorCasos::getMotorCasos()->calcularCaso(persona, personaPrev, suelo, caso, casoPrev);
		cout << "Estamos en el caso: " << caso << endl;
		if(caso==7 || caso==8){
			vector<CvPoint> brazos=detectarBrazos();
			CvRect r = detectarCabeza();
			persona.cabeza=r;
		}else if(caso<7){
			CvRect r = detectarCabeza();
			persona.cabeza=r;
			vector<CvPoint> brazos=detectarBrazos();
		}
		CvRect areaReducidaCuello_Hombros=cvRect(persona.min.x, persona.cabeza.y + persona.cabeza.height, persona.max.x - persona.min.x, (persona.max.y - persona.min.y)*0.2);
		vector<CvPoint> cuello_hombros = detectarCuello_HombrosConociendoCabeza(areaReducidaCuello_Hombros);

		vector<CvPoint> columna = detectarColumnaVertebral();
		persona.columnaVertebral = columna;
		detectarCadera();
		detectarPiernas();
		dibujarCuerpoHumano();
		volcarPersonaAEsqueleto();
		HistoricoEsqueletos::getHistoricoEsqueletos()->push_back(esqueleto);
		
		personaPrev=persona;//guardamos copia de la persona
		Persona p;
		persona = p;//reseteamos los datos
		casoPrev2=casoPrev;
		casoPrev=caso;
		

		t = (double)cvGetTickCount() - t;
		//cout << "tiempo en calcular las proyecciones = " << t/((double)cvGetTickFrequency()*1000.) << endl;
//	}

	//return frame;
//	return imgGray;
//	cvCvtColor(imgGray, imgRetorno, CV_GRAY2BGR);
	
	return imgRetorno;
}



vector<CvPoint> AnalisisPersona::detectarBrazos(void){
	vector<CvPoint> brazos, brazosSuperior, brazosInferior;//dos primeros puntos corresponden a inicio y fin de los dos brazos
	int i,j,k;
	CvScalar s,sl, sv;//s punto auxiliar; sd, punto de desplazamiento Lateral; sa, punto de desplazamiento vertical
	int banderaBajarCodo=0;
	for(i=0;i<3;i++){//inicializamoss el vector con cuatro elementos cuyo valor es (0,0)
		brazosSuperior.push_back(cvPoint(0,0));
		brazosInferior.push_back(cvPoint(0,0));
		brazos.push_back(cvPoint(0,0));
	}

	Esqueleto personaPrev1, personaPrev2;
	CvPoint vectorDireccionM1 = cvPoint(0,0);//direccion del movimiento de la mano1
	CvPoint vectorDireccionM2 = cvPoint(0,0);//direccion del movimiento de la mano2
	
	if(HistoricoEsqueletos::getHistoricoEsqueletos()->size()>0){
		personaPrev1=HistoricoEsqueletos::getHistoricoEsqueletos()->back();
		if(HistoricoEsqueletos::getHistoricoEsqueletos()->size()>1){//si tenemos dos iteraciones anteriores con info de esqueletos
			personaPrev2 =HistoricoEsqueletos::getHistoricoEsqueletos()->element(HistoricoEsqueletos::getHistoricoEsqueletos()->size()-2);
			vectorDireccionM1.x = personaPrev1.getBrazo1()[0].x - personaPrev2.getBrazo1()[0].x;
			vectorDireccionM1.y = personaPrev1.getBrazo1()[0].y - personaPrev2.getBrazo1()[0].y;
			vectorDireccionM2.x = personaPrev1.getBrazo2()[0].x - personaPrev2.getBrazo2()[0].x;
			vectorDireccionM2.y = personaPrev1.getBrazo2()[0].y - personaPrev2.getBrazo2()[0].y;
		}
	}

	if(caso<5){//requiere que previamente haya sido detectada y localizada la cabeza
		int desviacion=0.03*(persona.max.x - persona.min.x);
		brazosSuperior[0]=persona.PVC[0].puntos[0];//extremo de la mano
		brazosSuperior[1]=persona.PVC[0].puntos[(persona.cabeza.x - persona.min.x)/2];//codo
		if((persona.cabeza.x - persona.min.x -desviacion)>=0){
			brazosSuperior[2]=persona.PVC[0].puntos[persona.cabeza.x - persona.min.x -desviacion];//hombro
		}else if((persona.cabeza.x - persona.min.x)>0){
			brazosSuperior[2]=persona.PVC[0].puntos[persona.cabeza.x - persona.min.x];//hombro
		}else{
			brazosSuperior[2]=persona.PVC[0].puntos[0];//hombro
		}
		
		int numero = persona.PVC[0].puntos.size()-1;
		int numero2= (persona.cabeza.x - persona.min.x + persona.cabeza.width);
		numero +=numero2;
		numero=numero/2;
		int tama = persona.PVC[0].puntos.size();

		//Afinamos el calculo de los hombros
		//	Hombro de la izquierda
		CvPoint hombroIzquierdoIdeal = cvPoint(persona.cabeza.x - desviacion, persona.cabeza.y + 1.3*persona.cabeza.height);
		vector<int> competicionCandidatosHombroIzquierdo;
		for(i=0;i<persona.cabeza.x-persona.min.x;i++){
			int valor=0;
			valor=abs(persona.PVC[0].puntos[i].x - hombroIzquierdoIdeal.x) + 2*abs(persona.PVC[0].puntos[i].y - hombroIzquierdoIdeal.y);
			competicionCandidatosHombroIzquierdo.push_back(valor);
		}
		//realizamos el conteo
		int resultadoCompeticionHombro1=0;
		for(i=1;i<competicionCandidatosHombroIzquierdo.size();i++){
			if(competicionCandidatosHombroIzquierdo[i]<competicionCandidatosHombroIzquierdo[resultadoCompeticionHombro1]){
				resultadoCompeticionHombro1=i;
			}
		}
		brazosSuperior[2]=persona.PVC[0].puntos[resultadoCompeticionHombro1];
		//cvCircle( imgRetorno, brazosSuperior[2], 3, CV_RGB(255,200,0), -1, 8,0);


		





		
		/*---------------------------------------------------------------*/
		//caso del brazo de la izquierda
		//localizar la zona inferior del brazo, empezando desde el codo
		/*----------------------------------------------------------------*/
		double proporcionZonaBrazoIzquierda = 0.0 + (persona.cabeza.x - persona.PHD[0].puntos[persona.PHD[0].er.maxRel[0]].x)/(persona.cabeza.width);
		if(proporcionZonaBrazoIzquierda<1){//la zona es demasiado pequea para corresponder a un brazo estirado
			brazosSuperior[1]=persona.PHD[0].puntos[persona.PHD[0].er.maxRel[0]];//el codo es el maximo relativo
			for(i=brazosSuperior[1].y - persona.min.y; i<persona.PHD[0].puntos.size();i++){
				if(persona.PHD[0].puntos[i].x>=persona.cabeza.x){
					break;
				}
			}
			brazosSuperior[0]=persona.PHD[0].puntos[i-1];
			persona.brazo1.push_back(brazosSuperior[0]);
			persona.brazo1.push_back(brazosSuperior[1]);
			persona.brazo1.push_back(brazosSuperior[2]);
		}else{
			double pendiente = 0.0 + (brazosSuperior[2].y - brazosSuperior[0].y);
			pendiente= pendiente/ (brazosSuperior[2].x - brazosSuperior[0].x);
			if(pendiente<0)
				pendiente=pendiente*(-1);
			int ponderacionDesplazamientoX=0, ponderacionDesplazamientoY=0;
			if(pendiente>3){
				ponderacionDesplazamientoX=1;
				ponderacionDesplazamientoY=0;
			}
			if(pendiente<=3 || pendiente>0.75){
				ponderacionDesplazamientoX=1;
				ponderacionDesplazamientoY=1;
			}
			if(pendiente<=0.75){
				ponderacionDesplazamientoX=0;
				ponderacionDesplazamientoY=1;
			}

			i=brazosSuperior[1].x;
			j=brazosSuperior[1].y;

			while(banderaBajarCodo==0 && j<persona.max.y && i<persona.cabeza.x && i>persona.min.x){//recorremos el borde
				i=i+ponderacionDesplazamientoX;
				j=j+ponderacionDesplazamientoY;
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					banderaBajarCodo=1;
				}
				//cvCircle( imgRetorno, cvPoint(i,j), 3, CV_RGB(0,0,255), -1, 8,0);
			}
			banderaBajarCodo=0;
			//cvCircle( imgRetorno, cvPoint(i,j), 3, CV_RGB(0,0,255), -1, 8,0);
			while(banderaBajarCodo==0 && j<persona.max.y && i<persona.cabeza.x && i>persona.min.x){//recorremos el borde
				i=i+ponderacionDesplazamientoX;
				j=j+ponderacionDesplazamientoY;
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]>220){
					banderaBajarCodo=1;
				}
			}
			banderaBajarCodo=0;
			//cvCircle( imgRetorno, cvPoint(i,j), 3, CV_RGB(0,0,255), -1, 8,0);
			while(banderaBajarCodo==0 && j<persona.max.y && i<persona.cabeza.x && i>persona.min.x){//bajamos hasta encontrarnos superar el grueso de la linea que marca el borde del codo
				i=i+ponderacionDesplazamientoX;
				j=j+ponderacionDesplazamientoY;
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					banderaBajarCodo=1;
				}
			}
			banderaBajarCodo=0;
			//cvCircle( imgRetorno, cvPoint(i,j), 3, CV_RGB(0,0,255), -1, 8,0);
			while(banderaBajarCodo==0 && j<persona.max.y && i<persona.cabeza.x && i>persona.min.x){//final del grueso del borde inferior
				i=i+ponderacionDesplazamientoX;
				j=j+ponderacionDesplazamientoY;
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]>220){
					banderaBajarCodo=1;
				}
			}
			banderaBajarCodo=0;
			//cvCircle( imgRetorno, cvPoint(i,j), 3, CV_RGB(0,0,255), -1, 8,0);
			
			brazosInferior[1]=cvPoint(i,j);//introducimos la parte inferior del codo

			/*Ya hemos llegado hasta el otro lado
			  Ahora necesitamos recorrer la parte
			  inferior del brazo, hasta la axila*/

	//para garantizar que funcione cuando  el brazo esta levantado en lugar de bajado
			if(brazosSuperior[0].y>brazosSuperior[2].y){
				while(i>persona.min.x && j>persona.min.y && i<brazosSuperior[2].x){
					sl=cvGet2D(imgGray,j,i+1);
					sv=cvGet2D(imgGray,j-1,i);
					s.val[0]=100;
					cvCircle( imgGray, cvPoint(i,j), 1, s, -1, 8,0);
					if(sv.val[0]>254){
						j--;
					}else if(sl.val[0]>254){
						i++;
					}else{
						break;
					}
					//cvCircle( imgRetorno, cvPoint(i,j), 3, CV_RGB(255,0,0), -1, 8,0);	
				}
				brazosInferior[2]=cvPoint(i,j);
			}else{
				brazosInferior[2]=cvPoint(brazosSuperior[2].x,brazosSuperior[2].y + (brazosInferior[1].y - brazosSuperior[1].y));
			}
			brazosInferior[0]=cvPoint(brazosSuperior[0].x,(brazosSuperior[0].y + (brazosInferior[1].y - brazosSuperior[1].y)));
			
			brazos.clear();
			for(i=0;i<3;i++){//inicializamoss el vector con cuatro elementos cuyo valor es (0,0)
				brazos.push_back(cvPoint(0,0));
			}
			//calculamos la posicion final del brazo
			for(i=0;i<3;i++){
				if(i==2 || i==5){
					brazos[i].x = (brazosSuperior[i].x + brazosInferior[i].x) / 2;
					brazos[i].y = (1.3*brazosSuperior[i].y + 0.7*brazosInferior[i].y) / 2;
				}else{
					brazos[i].x = (brazosSuperior[i].x + brazosInferior[i].x) / 2;
					brazos[i].y = (brazosSuperior[i].y + brazosInferior[i].y) / 2;
				}
			}
			i=brazos[0].y;
			while(i>persona.PHD[0].puntos[persona.PHD[0].er.maxRel.back()].y){//si el brazo est muy abajo por error de precision, subirlo
				s=cvGet2D(imgGray,i,brazos[0].x);
				if(s.val[0]<220){
					brazos[0].y=i;
					break;
				}
				i--;
			}

			//guardamos datos
			for(i=0;i<3;i++){
				brazos.push_back(brazosSuperior[i]);
			}
			for(i=0;i<3;i++){
				brazos.push_back(brazosInferior[i]);
			}
			brazosSuperior.clear();
			brazosInferior.clear();

			/*guardamos los datos*/
			persona.brazo1.clear();
			persona.brazo1.push_back(brazos[0]);
			persona.brazo1.push_back(brazos[1]);
			persona.brazo1.push_back(brazos[2]);

			persona.brazo1Sup.clear();
			persona.brazo1Sup.push_back(brazos[3]);
			persona.brazo1Sup.push_back(brazos[4]);
			persona.brazo1Sup.push_back(brazos[5]);

			persona.brazo1Inf.clear();
			persona.brazo1Inf.push_back(brazos[6]);
			persona.brazo1Inf.push_back(brazos[7]);
			persona.brazo1Inf.push_back(brazos[8]);
		}//fin if-else de brazo izquierdo





		//inicializacin para la localizacin de los elementos de la zona derecha:
		//		hombro, codo, mano, etc
		for(i=0;i<3;i++){//inicializamoss el vector con cuatro elementos cuyo valor es (0,0)
			brazosSuperior.push_back(cvPoint(0,0));
			brazosInferior.push_back(cvPoint(0,0));
			brazos.push_back(cvPoint(0,0));
		}
		brazosSuperior[0]=persona.PVC[0].puntos[persona.PVC[0].puntos.size()-1];//extremo de la mano
		if(numero<persona.PVC[0].puntos.size()){
			brazosSuperior[1]=persona.PVC[0].puntos[numero];//codo
		}else{//no debera ocurrir
			brazosSuperior[1]=persona.PVC[0].puntos.back();//codo
		}
		if(persona.cabeza.x - persona.min.x + persona.cabeza.width +desviacion < persona.PVC[0].puntos.size()){
			brazosSuperior[2]=persona.PVC[0].puntos[persona.cabeza.x - persona.min.x + persona.cabeza.width +desviacion];//hombro
		}else{//no debera ocurrir
			brazosSuperior[2]=persona.PVC[0].puntos.back();//hombro
		}		
		//	Hombro de la derecha
		CvPoint hombroDerechoIdeal = cvPoint(persona.cabeza.x + persona.cabeza.height + desviacion, persona.cabeza.y + 1.3*persona.cabeza.height);
		vector<int> competicionCandidatosHombroDerecho;
		for(i=persona.cabeza.x-persona.min.x + persona.cabeza.width; i<persona.PVC[0].puntos.size(); i++){
			int valor=0;
			//cvCircle( imgRetorno, persona.PVC[0].puntos[i], 3, CV_RGB(0,0,255), -1, 8,0);
			valor=abs(persona.PVC[0].puntos[i].x - hombroDerechoIdeal.x) + 2*abs(persona.PVC[0].puntos[i].y - hombroDerechoIdeal.y);
			competicionCandidatosHombroDerecho.push_back(valor);
		}
		//realizamos el conteo
		int resultadoCompeticionHombro2=0;
		for(i=1;i<competicionCandidatosHombroDerecho.size();i++){
			if(competicionCandidatosHombroDerecho[i]<competicionCandidatosHombroDerecho[resultadoCompeticionHombro2]){
				resultadoCompeticionHombro2=i;
			}
		}
		if(resultadoCompeticionHombro2 + persona.cabeza.x-persona.min.x + persona.cabeza.width < persona.PVC[0].puntos.size()){
			brazosSuperior[2]=persona.PVC[0].puntos[resultadoCompeticionHombro2 + persona.cabeza.x-persona.min.x + persona.cabeza.width];
		}else{//no debera ocurrir
			brazosSuperior[2]=persona.PVC[0].puntos.back();
		}
		//cvCircle( imgRetorno, brazosSuperior[2], 3, CV_RGB(255,0,220), -1, 8,0);


		/*---------------------------------------------------------------*/
		//caso del brazo de la derecha
		//localizar la zona inferior del brazo, empezando desde el codo
		/*----------------------------------------------------------------*/

		double proporcionZonaBrazoDerecha = 0.0 + (persona.PHI[0].puntos[persona.PHI[0].er.minRel[0]].x - persona.cabeza.x - persona.cabeza.width)/(persona.cabeza.width);
		if(proporcionZonaBrazoDerecha<1){//la zona es demasiado pequea para corresponder a un brazo estirado
			brazosSuperior[1]=persona.PHI[0].puntos[persona.PHI[0].er.minRel[0]];//el codo es el maximo relativo
			for(i=brazosSuperior[1].y - persona.min.y; i<persona.PHI[0].puntos.size();i++){
				if(persona.PHI[0].puntos[i].x<=persona.cabeza.x + persona.cabeza.width){
					break;
				}
			}
			brazosSuperior[0]=persona.PHI[0].puntos[i-1];
			persona.brazo2.push_back(brazosSuperior[0]);
			persona.brazo2.push_back(brazosSuperior[1]);
			persona.brazo2.push_back(brazosSuperior[2]);
		}else{
			//ahora vamos a continuar buscando los puntos inferiores del brazo
			double pendiente=0.0;
			int ponderacionDesplazamientoX=0, ponderacionDesplazamientoY=0;

			pendiente= 0.0 + (brazosSuperior[2].y - brazosSuperior[0].y);
			pendiente= pendiente/ (brazosSuperior[2].x - brazosSuperior[0].x);
			if(pendiente<0)
				pendiente=pendiente*(-1);
			ponderacionDesplazamientoX=0;
			ponderacionDesplazamientoY=0;
			if(pendiente>3){
				ponderacionDesplazamientoX=-1;
				ponderacionDesplazamientoY=0;
			}
			if(pendiente<=3 || pendiente>0.75){
				ponderacionDesplazamientoX=-1;
				ponderacionDesplazamientoY=1;
			}
			if(pendiente<=0.75){
				ponderacionDesplazamientoX=0;
				ponderacionDesplazamientoY=1;
			}

			i=brazosSuperior[1].x;
			j=brazosSuperior[1].y;
			banderaBajarCodo=0;
			while(banderaBajarCodo==0 && j<persona.max.y && i>(persona.cabeza.x+persona.cabeza.width) && i>persona.min.x){//recorremos el borde
				i=i+ponderacionDesplazamientoX;
				j=j+ponderacionDesplazamientoY;
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					banderaBajarCodo=1;
				}
				//cvCircle( imgRetorno, cvPoint(i,j), 3, CV_RGB(0,0,255), -1, 8,0);
			}
			banderaBajarCodo=0;
			//cvCircle( imgRetorno, cvPoint(i,j), 3, CV_RGB(0,0,255), -1, 8,0);
			while(banderaBajarCodo==0 && j<persona.max.y && i>(persona.cabeza.x+persona.cabeza.width) && i>persona.min.x){//recorremos el borde
				i=i+ponderacionDesplazamientoX;
				j=j+ponderacionDesplazamientoY;
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]>220){
					banderaBajarCodo=1;
				}
			}
			banderaBajarCodo=0;
			//cvCircle( imgRetorno, cvPoint(i,j), 3, CV_RGB(0,0,255), -1, 8,0);
			while(banderaBajarCodo==0  && j<persona.max.y && i>(persona.cabeza.x+persona.cabeza.width) && i>persona.min.x){//bajamos hasta encontrarnos superar el grueso de la linea que marca el borde del codo
				i=i+ponderacionDesplazamientoX;
				j=j+ponderacionDesplazamientoY;
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					banderaBajarCodo=1;
				}
			}
			banderaBajarCodo=0;
			//cvCircle( imgRetorno, cvPoint(i,j), 3, CV_RGB(0,0,255), -1, 8,0);
			while(banderaBajarCodo==0  && j<persona.max.y && i>(persona.cabeza.x+persona.cabeza.width) && i>persona.min.x){//final del grueso del borde inferior
				i=i+ponderacionDesplazamientoX;
				j=j+ponderacionDesplazamientoY;
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]>220){
					banderaBajarCodo=1;
				}
			}
			banderaBajarCodo=0;
			//cvCircle( imgRetorno, cvPoint(i,j), 3, CV_RGB(0,0,255), -1, 8,0);
			
			brazosInferior[1]=cvPoint(i,j);//introducimos la parte inferior del codo

			/*Ya hemos llegado hasta el otro lado
			  Ahora necesitamos recorrer la parte
			  inferior del brazo, hasta la axila*/
			
	//para garantizar que funcione cuando  el brazo esta levantado en lugar de bajado
			if(brazosSuperior[0].y>brazosSuperior[2].y){
				while(i<persona.max.x && j>persona.min.y && i>brazosSuperior[2].x){
					sl=cvGet2D(imgGray,j,i-1);
					sv=cvGet2D(imgGray,j-1,i);
					s.val[0]=100;
					//cvCircle( imgGray, cvPoint(i,j), 1, s, -1, 8,0);
					if(sv.val[0]>254){
						j--;
					}else if(sl.val[0]>254){
						i--;
					}else{
						break;
					}
					//cvCircle( imgRetorno, cvPoint(i,j), 3, CV_RGB(255,0,0), -1, 8,0);
					
				}
				brazosInferior[2]=cvPoint(i,j);
			}else{
				brazosInferior[2]=cvPoint(brazosSuperior[2].x,brazosSuperior[2].y + (brazosInferior[1].y - brazosSuperior[1].y));
			}
			brazosInferior[0]=cvPoint(brazosSuperior[0].x,(brazosSuperior[0].y + (brazosInferior[1].y - brazosSuperior[1].y)));
			
			brazos.clear();
			for(i=0;i<3;i++){//inicializamoss el vector con cuatro elementos cuyo valor es (0,0)
				brazos.push_back(cvPoint(0,0));
			}
			//calculamos la posicion del brazo de la derecha
			for(i=0;i<3;i++){
				if(i==2 || i==5){
					brazos[i].x = (brazosSuperior[i].x + brazosInferior[i].x) / 2;
					brazos[i].y = (1.3*brazosSuperior[i].y + 0.7*brazosInferior[i].y) / 2;
				}else{
					brazos[i].x = (brazosSuperior[i].x + brazosInferior[i].x) / 2;
					brazos[i].y = (brazosSuperior[i].y + brazosInferior[i].y) / 2;
				}
			}

			i=brazos[0].y;
			while(i>persona.PHI[0].puntos[persona.PHI[0].er.minRel.back()].y){//si el brazo est muy abajo por error de precision, subirlo
				s=cvGet2D(imgGray,i,brazos[0].x);
				if(s.val[0]<220){
					brazos[0].y=i;
					break;
				}
				i--;
			}

			//guardamos datos
			for(i=0;i<3;i++){
				brazos.push_back(brazosSuperior[i]);
			}
			for(i=0;i<3;i++){
				brazos.push_back(brazosInferior[i]);
			}

			/*guardamos los datos*/
			persona.brazo2.clear();
			persona.brazo2.push_back(brazos[0]);
			persona.brazo2.push_back(brazos[1]);
			persona.brazo2.push_back(brazos[2]);

			persona.brazo2Sup.clear();
			persona.brazo2Sup.push_back(brazos[3]);
			persona.brazo2Sup.push_back(brazos[4]);
			persona.brazo2Sup.push_back(brazos[5]);

			persona.brazo2Inf.clear();
			persona.brazo2Inf.push_back(brazos[6]);
			persona.brazo2Inf.push_back(brazos[7]);
			persona.brazo2Inf.push_back(brazos[8]);
		}

	/*fin caso 4*/	
	}else if(caso==5){




		CvScalar s;
		int k, bandera;
		vector<CvPoint> candidatosMano1;
		CvPoint pCodoAux1, pCodoAux2, pCodoAux3; //parte superior del codo1, interseccin entre los dos brazos, y parte inferior del codo2
		vector<CvPoint> candidatospCodoAux2;
		CvPoint pMano1 = persona.PHD[0].puntos[persona.PHD[0].er.maxRel[persona.PHD[0].er.maxRel.size()-2]];//en principio se tratara a la mano1 como la mano superior (la que est por encima de la otra)
		CvPoint pMano2 = persona.PHD[0].puntos[persona.PHD[0].er.maxRel.back()];//en principio se tratar la mano2 como la mano inferior (la que est por debajo de la otra)
		

		//comprobamos candidatos mas probables teniendo en cuenta frames anteriores
		if(HistoricoEsqueletos::getHistoricoEsqueletos()->size()>0 && casoPrev>4){//si tenemoss informacion de iteraciones anteriores, intentaremos buscar aquel candidato que tenga mas probabilidades de ser	
			//Para la mano 1
			CvPoint candidatoAux =  pMano1;
			CvPoint candidatoM1 = personaPrev1.getBrazo1()[0];
			int valor1=100000, valor2=100000;//valores suficientemente grandes
			if(casoPrev2>4){
				candidatoM1.x+=vectorDireccionM1.x;
				candidatoM1.y+=vectorDireccionM1.y;
			}
			/*for(i=0;i<persona.PVC[0].er.maxRel.size();i++){//introducimos los candiddatos
				candidatosMano1.push_back(persona.PVC[0].puntos[persona.PVC[0].er.maxRel[i]]);
			}*/
			for(i=0;i<persona.PDD[0].er.maxRel.size();i++){//introducimos los candiddatos
				candidatosMano1.push_back(persona.PDD[0].puntos[persona.PDD[0].er.maxRel[i]]);//------------->creo que es maxrel
			}
			for(i=0;i<persona.PHD[0].er.maxRel.size();i++){//introducimos los candiddatos
				candidatosMano1.push_back(persona.PHD[0].puntos[persona.PHD[0].er.maxRel[i]]);
			}
			
			valor2 = abs(candidatoAux.x - candidatoM1.x);
			valor2 += abs(candidatoAux.y - candidatoM1.y);
			for(i=0;i<candidatosMano1.size();i++){//elegimos el candidato mas proximo
				valor1 = abs(candidatosMano1[i].x - candidatoM1.x);
				valor1 += abs(candidatosMano1[i].y - candidatoM1.y);
				if(abs(valor1) < abs(valor2)){
					candidatoAux=candidatosMano1[i];
					valor2=valor1;
				}
			}
			pMano1 = candidatoAux;//asignamos el candidato elegido

			//Para la mano2
			candidatoAux =  pMano2;
			candidatoM1 = personaPrev1.getBrazo2()[0];
			valor1=100000;
			valor2=100000;//valores suficientemente grandes

			if(casoPrev2>4){
				candidatoM1.x+=vectorDireccionM1.x;
				candidatoM1.y+=vectorDireccionM1.y;
			}
			valor2 = abs(candidatoAux.x - candidatoM1.x);
			valor2 += abs(candidatoAux.y - candidatoM1.y);
			for(i=0;i<candidatosMano1.size();i++){//elegimos el candidato mas proximo
				valor1 = abs(candidatosMano1[i].x - candidatoM1.x);
				valor1 += abs(candidatosMano1[i].y - candidatoM1.y);
				if(abs(valor1) < abs(valor2)){
					candidatoAux=candidatosMano1[i];
					valor2=valor1;
				}
			}
			pMano2 = candidatoAux;//asignamos el candidato elegido

		}
		if(pMano1.y==pMano2.y){//si son el mismo punto, volver a la solucion por defecto
			pMano1 = persona.PHD[0].puntos[persona.PHD[0].er.maxRel[persona.PHD[0].er.maxRel.size()-2]];//en principio se tratara a la mano1 como la mano superior (la que est por encima de la otra)
			pMano2 = persona.PHD[0].puntos[persona.PHD[0].er.maxRel.back()];//en principio se tratar la mano2 como la mano inferior (la que est por debajo de la otra)
		}else if(persona.PHD[0].er.maxRel.size()<2){//si solo hay un extremo relativo detectado, es porque la mano1 est arriba del todo y ese extremos ha sido obviado
			pMano1=persona.PVC[0].puntos[persona.PVC[0].er.maxRel[0]];
		}
		
		pCodoAux2=cvPoint((pMano1.x+pMano2.x)/2, (pMano1.y+pMano2.y)/2);//inicializacion por defecto. No es el valor correcto
		
		//buscamos el mejor candidato para  pcodoAux2
		i=0;
		j=0;
		CvPoint pExtremo1 = pMano1, pExtremo2 = pMano2, pIntermedio = cvPoint(0,0);//puntos de pivotaje
		for(k=0;k<3;k++){//algoritmo de 3 iteraciones
			pIntermedio.x = (pExtremo1.x + pExtremo2.x)/2;
			pIntermedio.y = (pExtremo1.y + pExtremo2.y)/2;
			i=pIntermedio.x;
			j=pIntermedio.y;
			//cvCircle( imgRetorno, pIntermedio, 3, CV_RGB(255,255,0), -1, 8,0);
			while(i>persona.min.x && i<persona.max.x && j>persona.min.y && j<persona.max.y){
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					break;
				}
				i++;
				//cvCircle( imgRetorno, cvPoint(i,j), 3, CV_RGB(255,255,0), -1, 8,0);
			}
			while(i>persona.min.x && i<persona.max.x && j>persona.min.y && j<persona.max.y){
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					break;
				}
				i++;
				j++;
			}
			pExtremo2.x=i;
			pExtremo2.y=j;
			i--;
			j--;
			while(i>persona.min.x && i<persona.max.x && j>persona.min.y && j<persona.max.y){//buscamos pExtremo1
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					break;
				}
				i++;
				j--;
			}
			pExtremo1.x=i;
			pExtremo1.y=j;

			i=pExtremo2.x - 1;
			j=pExtremo2.y - 1;

			while(i>persona.min.x && i<persona.max.x && j>persona.min.y && j<persona.max.y){//buscamos pExtremo2
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					break;
				}
				j++;
			}
			pExtremo2.x=i;
			pExtremo2.y=j;
		}
		pCodoAux2 = cvPoint((pExtremo1.x + pExtremo2.x)/2, (pExtremo1.y + pExtremo2.y)/2);
		pCodoAux1= cvPoint(pCodoAux2.x, persona.PVC[0].puntos[pCodoAux2.x - persona.min.x].y);
		CvPoint pCodo1 = cvPoint((pCodoAux1.x + pCodoAux2.x)/2, (pCodoAux1.y + pCodoAux2.y)/2);//obtenemos el primer codo (el de pMano1)
		pCodoAux3 = cvPoint(pCodoAux2.x, persona.max.y);//inicializacion por defecto

		for(i=pCodoAux3.y; i>pExtremo2.y; i--){//nos aproximamos al codo desde la zona inferior
			s=cvGet2D(imgGray,i,pCodoAux3.x);
			if(s.val[0]<220){
				break;
			}
		}
		pCodoAux3.y = i;
		CvPoint pCodo2 = cvPoint((pCodoAux3.x + pCodoAux2.x)/2, (pCodoAux3.y + pCodoAux2.y)/2);//obtenemos el segundo codo (el de pMano2)

		//antiguo del caso simetrico		
/*		CvPoint aux1 = cvPoint((persona.PHI[0].puntos[persona.PHI[0].er.maxRel.back()].x + persona.PVC[0].puntos[persona.PVC[0].er.minRel.back()].x)/2, (persona.PHI[0].puntos[persona.PHI[0].er.maxRel.back()].y + persona.PVC[0].puntos[persona.PVC[0].er.minRel.back()].y)/2);
		double pendienteBrazo1 =0.1000;
		//cout << "(" << aux1.y << " - " << persona.PHD[0].puntos[persona.PHD[0].er.maxRel[0]].y << ") / (" << aux1.x << " - " << persona.PHD[0].puntos[persona.PHD[0].er.maxRel[0]].x << ") = ";
		pendienteBrazo1 = (aux1.y - persona.PHI[0].puntos[persona.PHI[0].er.minRel[0]].y);
		pendienteBrazo1= pendienteBrazo1/(aux1.x - persona.PHI[0].puntos[persona.PHI[0].er.minRel[0]].x);
		//cout << pendienteBrazo1 << endl;
*/		
		
		bandera=0;
		int xVal=0, yVal=0;
		if(persona.PHI[0].er.minRel.size()>0){
			for(i=0;i<persona.PHI[0].er.minRel.size();i++){
				if((persona.PHI[0].er.minRel[i] > persona.cabeza.height) && (persona.PHI[0].er.minRel[i]< (persona.max.y-persona.min.y-persona.cabeza.height)/2)){
					yVal=persona.PHI[0].puntos[persona.PHI[0].er.minRel[i]].y;
					xVal=persona.PHI[0].puntos[persona.PHI[0].er.minRel[i]].x;
					bandera=1;
					break;
				}
			}
		}
		if(bandera==0 || persona.PHI[0].er.maxRel.size()==0){//en caso contrario (else)
			yVal=persona.cabeza.y + 1.1*persona.cabeza.height;
			xVal=persona.PHI[0].puntos[yVal-persona.min.y].x;
		}
		CvPoint pHombro1 = cvPoint(xVal,yVal);
		
		
/*		double pendienteBrazo2 = 0.100;
		pendienteBrazo2 = ( pMano2.y - pCodo2.y);
		pendienteBrazo2 = pendienteBrazo2/ (pMano2.x - pCodo2.x);
		CvPoint pHombro2 = cvPoint(persona.min.x, pCodo2.y + (pCodo2.x - persona.min.x)*pendienteBrazo2);
*/
		bandera=0;
		if(persona.PVC[0].er.maxRel.size()==2){
			if(persona.PVC[0].er.minRel.size()==1){
				xVal=persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]].x;
				yVal=persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]].y;
				bandera=1;
			}else if(persona.PVC[0].er.minRel.size()==3){
				xVal=persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]].x;
				yVal=persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]].y;
				bandera=1;
			}
		}
		if(bandera==0){
			xVal=persona.cabeza.x + persona.cabeza.width + 5;
			yVal=pHombro1.y;
		}
		CvPoint pHombro2 = cvPoint(xVal,yVal);

		brazos.clear();
		if(pMano1.y<pMano2.y)
			brazos.push_back(pMano1);//1
		else
			brazos.push_back(pMano2);//1
		if(pCodo1.y<pCodo2.y)
			brazos.push_back(pCodo1);//2
		else
			brazos.push_back(pCodo2);//2
		brazos.push_back(pHombro1);//3
		if(pMano1.y<pMano2.y)
			brazos.push_back(pMano2);//4
		else
			brazos.push_back(pMano1);//4
		if(pCodo1.y<pCodo2.y)
			brazos.push_back(pCodo2);//5
		else
			brazos.push_back(pCodo1);//5
		brazos.push_back(pHombro2);//6
		
		persona.brazo1.clear();
		persona.brazo1.push_back(brazos[0]);
		persona.brazo1.push_back(brazos[1]);
		persona.brazo1.push_back(brazos[2]);
		persona.brazo2.clear();
		persona.brazo2.push_back(brazos[3]);
		persona.brazo2.push_back(brazos[4]);
		persona.brazo2.push_back(brazos[5]);





		
	//fin if caso 5

	}else if(caso==6){
		CvScalar s;
		int k, bandera;
		vector<CvPoint> candidatosMano1;
		CvPoint pCodoAux1, pCodoAux2, pCodoAux3; //parte superior del codo1, interseccin entre los dos brazos, y parte inferior del codo2
		vector<CvPoint> candidatospCodoAux2;
		CvPoint pMano1 = persona.PHI[0].puntos[persona.PHI[0].er.minRel[persona.PHI[0].er.minRel.size()-2]];//en principio se tratara a la mano1 como la mano superior (la que est por encima de la otra)
		CvPoint pMano2 = persona.PHI[0].puntos[persona.PHI[0].er.minRel.back()];//en principio se tratar la mano2 como la mano inferior (la que est por debajo de la otra)
		

		//comprobamos candidatos mas probables teniendo en cuenta frames anteriores
		//if(HistoricoEsqueletos::getHistoricoEsqueletos()->size()>0 && casoPrev>4){//si tenemoss informacion de iteraciones anteriores, intentaremos buscar aquel candidato que tenga mas probabilidades de ser	
		//	//Para la mano 1
		//	CvPoint candidatoAux =  pMano1;
		//	CvPoint candidatoM1 = personaPrev1.getBrazo1()[0];
		//	int valor1=100000, valor2=100000;//valores suficientemente grandes
		//	if(casoPrev2>4){
		//		candidatoM1.x+=vectorDireccionM1.x;
		//		candidatoM1.y+=vectorDireccionM1.y;
		//	}
		//	/*for(i=0;i<persona.PVC[0].er.maxRel.size();i++){//introducimos los candiddatos
		//		candidatosMano1.push_back(persona.PVC[0].puntos[persona.PVC[0].er.maxRel[i]]);
		//	}*/
		//	for(i=0;i<persona.PDI[0].er.maxRel.size();i++){//introducimos los candiddatos
		//		candidatosMano1.push_back(persona.PDI[0].puntos[persona.PDI[0].er.maxRel[i]]);
		//	}
		//	for(i=0;i<persona.PHI[0].er.minRel.size();i++){//introducimos los candiddatos
		//		candidatosMano1.push_back(persona.PHI[0].puntos[persona.PHI[0].er.minRel[i]]);
		//	}
		//	
		//	valor2 = abs(candidatoAux.x - candidatoM1.x);
		//	valor2 += abs(candidatoAux.y - candidatoM1.y);
		//	for(i=0;i<candidatosMano1.size();i++){//elegimos el candidato mas proximo
		//		valor1 = abs(candidatosMano1[i].x - candidatoM1.x);
		//		valor1 += abs(candidatosMano1[i].y - candidatoM1.y);
		//		if(abs(valor1) < abs(valor2)){
		//			candidatoAux=candidatosMano1[i];
		//			valor2=valor1;
		//		}
		//	}
		//	pMano1 = candidatoAux;//asignamos el candidato elegido

		//	//Para la mano2
		//	candidatoAux =  pMano2;
		//	candidatoM1 = personaPrev1.getBrazo2()[0];
		//	valor1=100000;
		//	valor2=100000;//valores suficientemente grandes
		//	if(casoPrev2>4){
		//		candidatoM1.x+=vectorDireccionM2.x;
		//		candidatoM1.y+=vectorDireccionM2.y;
		//	}
		//	valor2 = abs(candidatoAux.x - candidatoM1.x);
		//	valor2 += abs(candidatoAux.y - candidatoM1.y);
		//	for(i=0;i<candidatosMano1.size();i++){//elegimos el candidato mas proximo
		//		valor1 = abs(candidatosMano1[i].x - candidatoM1.x);
		//		valor1 += abs(candidatosMano1[i].y - candidatoM1.y);
		//		if(abs(valor1) < abs(valor2)){
		//			candidatoAux=candidatosMano1[i];
		//			valor2=valor1;
		//		}
		//	}
		//	pMano2 = candidatoAux;//asignamos el candidato elegido

		//}

		if(pMano1.y==pMano2.y){//si son el mismo punto
			pMano1 = persona.PHI[0].puntos[persona.PHI[0].er.minRel[persona.PHI[0].er.minRel.size()-2]];//en principio se tratara a la mano1 como la mano superior (la que est por encima de la otra)
			pMano2 = persona.PHI[0].puntos[persona.PHI[0].er.minRel.back()];//en principio se tratar la mano2 como la mano inferior (la que est por debajo de la otra)
		}else if(persona.PHI[0].er.minRel.size()<2){//si solo hay un extremo relativo detectado, es porque la mano1 est arriba del todo y ese extremos ha sido obviado
			pMano1=persona.PVC[0].puntos[persona.PVC[0].er.maxRel.back()];
		}
		
		pCodoAux2=cvPoint((pMano1.x+pMano2.x)/2, (pMano1.y+pMano2.y)/2);//inicializacion por defecto. No es el valor correcto
		cvCircle( imgRetorno, pMano1, 3, CV_RGB(255,0,0), -1, 8,0);
		cvCircle( imgRetorno, pMano2, 3, CV_RGB(255,0,255), -1, 8,0);
		//cvCircle( imgRetorno, pCodoAux2, 3, CV_RGB(255,255,0), -1, 8,0);
		//buscamos el mejor candidato para  pcodoAux2
		i=0;
		j=0;
		CvPoint pExtremo1 = pMano1, pExtremo2 = pMano2, pIntermedio = cvPoint(0,0);//puntos de pivotaje
		for(k=0;k<3;k++){
			pIntermedio.x = (pExtremo1.x + pExtremo2.x)/2;
			pIntermedio.y = (pExtremo1.y + pExtremo2.y)/2;
			i=pIntermedio.x;
			j=pIntermedio.y;
			//cvCircle( imgRetorno, pIntermedio, 3, CV_RGB(255,255,0), -1, 8,0);
			while(i>persona.min.x && j>persona.min.y && j<persona.max.y){
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					break;
				}
				i--;
				//cvCircle( imgRetorno, cvPoint(i,j), 3, CV_RGB(255,255,0), -1, 8,0);
			}
			while(i>persona.min.x && i<persona.max.x && j>persona.min.y && j<persona.max.y){
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					break;
				}
				i--;
				j++;
				//cvCircle( imgRetorno, cvPoint(i,j), 3, CV_RGB(255,255,0), -1, 8,0);
			}
			pExtremo2.x=i;
			pExtremo2.y=j;
			i++;
			j--;
			while(i>persona.min.x && i<persona.max.x && j>persona.min.y && j<persona.max.y){//buscamos pExtremo1
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					break;
				}
				i--;
				j--;
				//cvCircle( imgRetorno, cvPoint(i,j), 3, CV_RGB(255,255,0), -1, 8,0);
			}
			pExtremo1.x=i;
			pExtremo1.y=j;

			i=pExtremo2.x + 1;
			j=pExtremo2.y - 1;

			while(i>persona.min.x && i<persona.max.x && j>persona.min.y && j<persona.max.y){//buscamos pExtremo2
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					break;
				}
				j++;
				//cvCircle( imgRetorno, cvPoint(i,j), 3, CV_RGB(255,255,0), -1, 8,0);
			}
			pExtremo2.x=i;
			pExtremo2.y=j;
		}
		pCodoAux2 = cvPoint((pExtremo1.x + pExtremo2.x)/2, (pExtremo1.y + pExtremo2.y)/2);
		
		//cvCircle( imgRetorno, pCodoAux2, 3, CV_RGB(0,255,255), -1, 8,0);

		if(pCodoAux2.x>=(persona.PVC[0].puntos.size()+persona.min.x)){//esto luego hay que quitarlo
			pCodoAux2.x=persona.PVC[0].puntos.size()-1 + persona.min.x;
		}
		pCodoAux1= cvPoint(pCodoAux2.x, persona.PVC[0].puntos[pCodoAux2.x - persona.min.x].y);
		CvPoint pCodo1 = cvPoint((pCodoAux1.x + pCodoAux2.x)/2, (pCodoAux1.y + pCodoAux2.y)/2);//obtenemos el primer codo (el de pMano1)
		pCodoAux3 = cvPoint(pCodoAux2.x, persona.max.y);//inicializacion por defecto

		for(i=pCodoAux3.y; i>pExtremo2.y; i--){//nos aproximamos al codo desde la zona inferior
			s=cvGet2D(imgGray,i,pCodoAux3.x);
			if(s.val[0]<220){
				break;
			}
		}
		pCodoAux3.y = i;
		CvPoint pCodo2 = cvPoint((pCodoAux3.x + pCodoAux2.x)/2, (pCodoAux3.y + pCodoAux2.y)/2);//obtenemos el segundo codo (el de pMano2)

		
		
/*		CvPoint aux1 = cvPoint((persona.PHI[0].puntos[persona.PHI[0].er.maxRel.back()].x + persona.PVC[0].puntos[persona.PVC[0].er.minRel.back()].x)/2, (persona.PHI[0].puntos[persona.PHI[0].er.maxRel.back()].y + persona.PVC[0].puntos[persona.PVC[0].er.minRel.back()].y)/2);
		double pendienteBrazo1 =0.1000;
		//cout << "(" << aux1.y << " - " << persona.PHD[0].puntos[persona.PHD[0].er.maxRel[0]].y << ") / (" << aux1.x << " - " << persona.PHD[0].puntos[persona.PHD[0].er.maxRel[0]].x << ") = ";
		pendienteBrazo1 = (aux1.y - persona.PHI[0].puntos[persona.PHI[0].er.minRel[0]].y);
		pendienteBrazo1= pendienteBrazo1/(aux1.x - persona.PHI[0].puntos[persona.PHI[0].er.minRel[0]].x);
		//cout << pendienteBrazo1 << endl;
*/		
		
		bandera=0;
		int xVal=0, yVal=0;
		if(persona.PHD[0].er.maxRel.size()>0){
			for(i=0;i<persona.PHD[0].er.maxRel.size();i++){
				if((persona.PHD[0].er.maxRel[i] > persona.cabeza.height) && (persona.PHD[0].er.maxRel[i]< (persona.max.y-persona.min.y-persona.cabeza.height)/2)){
					yVal=persona.PHD[0].puntos[persona.PHD[0].er.maxRel[i]].y;
					xVal=persona.PHD[0].puntos[persona.PHD[0].er.maxRel[i]].x;
					bandera=1;
					break;
				}
			}
		}
		if(bandera==0 || persona.PHD[0].er.maxRel.size()==0){//en caso contrario (else)
			yVal=persona.cabeza.y + 1.1*persona.cabeza.height;
			xVal=persona.PHD[0].puntos[yVal-persona.min.y].x;
		}
		CvPoint pHombro1 = cvPoint(xVal,yVal);
		
		
/*		double pendienteBrazo2 = 0.100;
		pendienteBrazo2 = ( pMano2.y - pCodo2.y);
		pendienteBrazo2 = pendienteBrazo2/ (pMano2.x - pCodo2.x);
		CvPoint pHombro2 = cvPoint(persona.min.x, pCodo2.y + (pCodo2.x - persona.min.x)*pendienteBrazo2);
*/
		bandera=0;
		if(persona.PVC[0].er.maxRel.size()==2){
			if(persona.PVC[0].er.minRel.size()==1){
				xVal=persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]].x;
				yVal=persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]].y;
				bandera=1;
			}else if(persona.PVC[0].er.minRel.size()==3){
				xVal=persona.PVC[0].puntos[persona.PVC[0].er.minRel[1]].x;
				yVal=persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]].y;
				bandera=1;
			}
		}
		if(bandera==0){
			xVal=persona.cabeza.x + persona.cabeza.width + 5;
			yVal=pHombro1.y;
		}
		CvPoint pHombro2 = cvPoint(xVal,yVal);

		brazos.clear();
		if(pMano1.y<pMano2.y)
			brazos.push_back(pMano1);//1
		else
			brazos.push_back(pMano2);//1
		if(pCodo1.y<pCodo2.y)
			brazos.push_back(pCodo1);//2
		else
			brazos.push_back(pCodo2);//2
		brazos.push_back(pHombro1);//3
		if(pMano1.y<pMano2.y)
			brazos.push_back(pMano2);//4
		else
			brazos.push_back(pMano1);//4
		if(pCodo1.y<pCodo2.y)
			brazos.push_back(pCodo2);//5
		else
			brazos.push_back(pCodo1);//5
		brazos.push_back(pHombro2);//6
		
		persona.brazo1.clear();
		persona.brazo1.push_back(brazos[0]);
		persona.brazo1.push_back(brazos[1]);
		persona.brazo1.push_back(brazos[2]);
		persona.brazo2.clear();
		persona.brazo2.push_back(brazos[3]);
		persona.brazo2.push_back(brazos[4]);
		persona.brazo2.push_back(brazos[5]);
	//fin if caso 6




	}else if(caso==7){
		CvPoint hombro1Anterior;
		vector<CvPoint> candidatosMano1;
		int sinReferenciaHombro1=0;//0 si se puede sacar informacin de las proyecciones; cualquier otro valor si no se puede obtener informacin significativa
		if(persona.PHD[0].er.maxRel.size()>0){
			hombro1Anterior= persona.PHD[0].puntos[persona.PHD[0].er.maxRel.back()];//entendemos que el hombro sobresale del resto del cuerpo
		}else{
			sinReferenciaHombro1=-1;
		}
		CvPoint mano1 = persona.PVC[0].puntos[persona.PVC[0].er.maxRel[0]];//solucion por defecto
		if(persona.PHI[0].er.minRel.size()>=2){
			mano1 = persona.PHI[0].puntos[persona.PHI[0].er.minRel[0]];
		}
		CvPoint mano2 = persona.PHI[0].puntos[persona.PHI[0].er.minRel.back()];//solucion por defecto
		cvCircle( imgRetorno, mano1, 3, CV_RGB(255,0,0), -1, 8,0);
		cvCircle( imgRetorno, mano2, 3, CV_RGB(255,0,0), -1, 8,0);
		if(HistoricoEsqueletos::getHistoricoEsqueletos()->size()>0 && casoPrev>4){//si tenemoss informacion de iteraciones anteriores, intentaremos buscar aquel candidato que tenga mas probabilidades de ser	
			CvPoint candidatoAux =  mano1;
			CvPoint candidatoM1 = personaPrev1.getBrazo1()[0];
			int valor1=100000, valor2=100000;//valores suficientemente grandes
			candidatoM1.x+=vectorDireccionM1.x;
			candidatoM1.y+=vectorDireccionM1.y;
			for(i=0;i<persona.PDD[0].er.maxRel.size();i++){//introducimos los candiddatos
				candidatosMano1.push_back(persona.PDD[0].puntos[persona.PDD[0].er.maxRel[i]]);
			}
			for(i=0;i<persona.PVC[0].er.maxRel.size();i++){//introducimos los candiddatos
				candidatosMano1.push_back(persona.PVC[0].puntos[persona.PVC[0].er.maxRel[i]]);
			}
			for(i=0;i<persona.PDI[0].er.maxRel.size();i++){//introducimos los candiddatos
				candidatosMano1.push_back(persona.PDI[0].puntos[persona.PDI[0].er.maxRel[i]]);
			}
			
			valor2 = abs(candidatoAux.x - candidatoM1.x);
			valor2 += abs(candidatoAux.y - candidatoM1.y);
			for(i=0;i<candidatosMano1.size();i++){//elegimos el candidato mas proximo
				valor1 = abs(candidatosMano1[i].x - candidatoM1.x);
				valor1 += abs(candidatosMano1[i].y - candidatoM1.y);
				if(abs(valor1) < abs(valor2)){
					candidatoAux=candidatosMano1[i];
					valor2=valor1;
				}
			}
			mano1 = candidatoAux;//asignamos el candidato elegido

			//Para la mano2
			candidatoAux =  mano2;
			candidatoM1 = personaPrev1.getBrazo2()[0];
			valor1=100000;
			valor2=100000;//valores suficientemente grandes
			candidatoM1.x+=vectorDireccionM1.x;
			candidatoM1.y+=vectorDireccionM1.y;
			valor2 = abs(candidatoAux.x - candidatoM1.x);
			valor2 += abs(candidatoAux.y - candidatoM1.y);
			for(i=0;i<candidatosMano1.size();i++){//elegimos el candidato mas proximo
				valor1 = abs(candidatosMano1[i].x - candidatoM1.x);
				valor1 += abs(candidatosMano1[i].y - candidatoM1.y);
				if(abs(valor1) < abs(valor2)){
					candidatoAux=candidatosMano1[i];
					valor2=valor1;
				}
			}
			mano2 = candidatoAux;//asignamos el candidato elegido
		}
		
		i=0;
		j=0;
		int k;
		CvPoint pExtremo1 = mano1, pExtremo2 = mano2, pIntermedio = cvPoint(0,0);
		cvCircle( imgRetorno, mano1, 3, CV_RGB(255,255,0), -1, 8,0);
		cvCircle( imgRetorno, mano2, 3, CV_RGB(255,255,0), -1, 8,0);
		for(k=0;k<3;k++){
			pIntermedio.x = (pExtremo1.x + pExtremo2.x)/2;
			pIntermedio.y = (pExtremo1.y + pExtremo2.y)/2;
			i=pIntermedio.x;
			j=pIntermedio.y;
			//cvCircle( imgRetorno, pIntermedio, 3, CV_RGB(255,255,0), -1, 8,0);
			while(i>persona.min.x && i<persona.max.x && j>persona.min.y && j<persona.max.y){
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					break;
				}
				i--;
				j++;
			}
			pExtremo2.x=i;
			pExtremo2.y=j;
			i++;
			j--;
			while(i>persona.min.x && i<persona.max.x && j>persona.min.y && j<persona.max.y){//buscamos pExtremo1
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					break;
				}
				i--;
				j--;
			}
			pExtremo1.x=i;
			pExtremo1.y=j;

			i=pExtremo2.x + 1;
			j=pExtremo2.y - 1;

			while(i>persona.min.x && i<persona.max.x && j>persona.min.y && j<persona.max.y){//buscamos pExtremo2
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					break;
				}
				j++;
			}
			pExtremo2.x=i;
			pExtremo2.y=j;
			if(pExtremo2.y<persona.min.y){
				pExtremo2.y=persona.min.y;
			}
		}
		if(pExtremo1.y<persona.min.y){
			pExtremo1.y=persona.min.y;
		}
		if(pExtremo2.y<persona.min.y){
			pExtremo2.y=persona.min.y;
		}
		CvPoint hombro2Superior = cvPoint((pExtremo1.x + pExtremo2.x)/2, (pExtremo1.y + pExtremo2.y)/2);
		CvPoint codo2Superior = cvPoint((hombro2Superior.x + mano2.x)/2, (hombro2Superior.y + mano2.y)/2);
		
//		cvCircle( imgRetorno, hombro1Anterior, 3, CV_RGB(0,255,0), -1, 8,0);
//		cvCircle( imgRetorno, hombro2Superior, 3, CV_RGB(0,255,0), -1, 8,0);
		/*Comprobamos que el primer hombro y codo son correctos*/
		double pendienteHombros = 0.0;
		if(sinReferenciaHombro1==0){//si hemos conseguido una buena referencia del hombro
			pendienteHombros = (hombro1Anterior.y - hombro2Superior.y);
			pendienteHombros = pendienteHombros /(hombro1Anterior.x - hombro2Superior.x);
		}
		if(sinReferenciaHombro1!=0 || pendienteHombros > 0.4 || pendienteHombros<-1.5){
			hombro1Anterior = persona.PHD[0].puntos[hombro2Superior.y - persona.min.y];
		}
		int posCodo1Anterior=(hombro1Anterior.y + mano1.y - 2*persona.min.y)/2;
		if(posCodo1Anterior>=persona.PHD[0].puntos.size()){
			posCodo1Anterior=persona.PHD[0].puntos.size()-1;
		}
		CvPoint codo1Anterior = persona.PHD[0].puntos[posCodo1Anterior];//el punto medio entre la mano y el hombro
		
		CvPoint codo1Reverso = cvPoint((mano1.x + codo2Superior.x)/2,codo1Anterior.y);
		
		for(i=codo1Reverso.x;i>persona.min.x;i--){
			s=cvGet2D(imgGray,codo1Reverso.y,i);
			if(s.val[0]<220){
				break;
			}
		}
		codo1Reverso.x=i;
		//ahora calcular el punto medio del codo
		CvPoint codo1=cvPoint((codo1Anterior.x+codo1Reverso.x)/2,(codo1Anterior.y+codo1Reverso.y)/2);
		CvPoint hombro1=cvPoint(hombro1Anterior.x+(codo1.x-codo1Anterior.x), hombro1Anterior.y);
		//calculamos los extremos inferiores del codo del brazo de la derecha
		for(i=persona.max.y; i>persona.min.y; i--){//primero el codo
			s=cvGet2D(imgGray,i,codo2Superior.x);
			if(s.val[0]<220){
				break;
			}
		}
		CvPoint codo2Inferior=cvPoint(codo2Superior.x, i);
		CvPoint codo2=cvPoint((codo2Inferior.x+codo2Superior.x)/2,(codo2Inferior.y+codo2Superior.y)/2);
		//calculamos los extremos inferiores del hombro del brazo de la derecha
		for(i=persona.max.y; i>persona.min.y; i--){//primero el codo
			s=cvGet2D(imgGray,i,hombro2Superior.x + 10);
			if(s.val[0]<220){
				break;
			}
		}
		CvPoint hombro2Inferior=cvPoint(hombro2Superior.x, i);
		CvPoint hombro2=cvPoint((hombro2Inferior.x+hombro2Superior.x)/2,(hombro2Inferior.y+hombro2Superior.y)/2);
		
		brazos.clear();
		brazos.push_back(mano1);
		brazos.push_back(codo1);
		brazos.push_back(hombro1);
		brazos.push_back(mano2);
		brazos.push_back(codo2);
		brazos.push_back(hombro2);

		persona.brazo1.clear();
		persona.brazo1.push_back(brazos[0]);
		persona.brazo1.push_back(brazos[1]);
		persona.brazo1.push_back(brazos[2]);
		persona.brazo2.clear();
		persona.brazo2.push_back(brazos[3]);
		persona.brazo2.push_back(brazos[4]);
		persona.brazo2.push_back(brazos[5]);

		/*cvCircle( imgRetorno, brazos[0], 3, CV_RGB(0,255,0), -1, 8,0);
		cvCircle( imgRetorno, brazos[1], 3, CV_RGB(0,255,0), -1, 8,0);
		cvCircle( imgRetorno, brazos[2], 3, CV_RGB(0,255,0), -1, 8,0);
		cvCircle( imgRetorno, brazos[3], 3, CV_RGB(0,255,0), -1, 8,0);
		cvCircle( imgRetorno, brazos[4], 3, CV_RGB(0,255,0), -1, 8,0);
		cvCircle( imgRetorno, brazos[5], 3, CV_RGB(0,255,0), -1, 8,0);*/
		//fin if caso 7
	}else if(caso==8){





		CvPoint hombro2Anterior;
		vector<CvPoint> candidatosMano1;
		
		CvPoint mano2 = persona.PVC[0].puntos[persona.PVC[0].er.maxRel.back()];//solucion por defecto
		CvPoint mano1 = persona.PHD[0].puntos[persona.PHD[0].er.maxRel.back()];//solucion por defecto
		
		if(HistoricoEsqueletos::getHistoricoEsqueletos()->size()>0){//si tenemoss informacion de iteraciones anteriores, intentaremos buscar aquel candidato que tenga mas probabilidades de ser	
			CvPoint candidatoAux =  mano1;
			CvPoint candidatoM1 = personaPrev1.getBrazo1()[0];
			int valor1=100000, valor2=100000;//valores suficientemente grandes
			candidatoM1.x+=vectorDireccionM1.x;
			candidatoM1.y+=vectorDireccionM1.y;
			for(i=0;i<persona.PHD[0].er.maxRel.size();i++){//introducimos los candiddatos
				candidatosMano1.push_back(persona.PHD[0].puntos[persona.PHD[0].er.maxRel[i]]);
			}
			for(i=0;i<persona.PDD[0].er.maxRel.size();i++){//introducimos los candiddatos
				candidatosMano1.push_back(persona.PDD[0].puntos[persona.PDD[0].er.maxRel[i]]);
			}
			for(i=0;i<persona.PVC[0].er.maxRel.size();i++){//introducimos los candiddatos
				candidatosMano1.push_back(persona.PVC[0].puntos[persona.PVC[0].er.maxRel[i]]);
			}
			for(i=0;i<persona.PDI[0].er.maxRel.size();i++){//introducimos los candiddatos
				candidatosMano1.push_back(persona.PDI[0].puntos[persona.PDI[0].er.maxRel[i]]);
			}
			
			valor2 = abs(candidatoAux.x - candidatoM1.x);
			valor2 += abs(candidatoAux.y - candidatoM1.y);
			for(i=0;i<candidatosMano1.size();i++){//elegimos el candidato mas proximo
				valor1 = abs(candidatosMano1[i].x - candidatoM1.x);
				valor1 += abs(candidatosMano1[i].y - candidatoM1.y);
				if(abs(valor1) < abs(valor2)){
					candidatoAux=candidatosMano1[i];
					valor2=valor1;
				}
			}
			mano1 = candidatoAux;//asignamos el candidato elegido

			//Para la mano2
			candidatoAux =  mano2;
			candidatoM1 = personaPrev1.getBrazo2()[0];
			valor1=100000;
			valor2=100000;//valores suficientemente grandes
			candidatoM1.x+=vectorDireccionM2.x;
			candidatoM1.y+=vectorDireccionM2.y;
			valor2 = abs(candidatoAux.x - candidatoM1.x);
			valor2 += abs(candidatoAux.y - candidatoM1.y);
			for(i=0;i<candidatosMano1.size();i++){//elegimos el candidato mas proximo
				valor1 = abs(candidatosMano1[i].x - candidatoM1.x);
				valor1 += abs(candidatosMano1[i].y - candidatoM1.y);
				if(abs(valor1) < abs(valor2)){
					candidatoAux=candidatosMano1[i];
					valor2=valor1;
				}
			}
			mano2 = candidatoAux;//asignamos el candidato elegido
		}
		
		i=0;
		j=0;
		int k;

		//cvCircle( imgRetorno, mano1, 3, CV_RGB(0,255,200), -1, 8,0);
		//cvCircle( imgRetorno, mano2, 3, CV_RGB(255,255,0), -1, 8,0);

		CvPoint pExtremo1 = mano1, pExtremo2 = mano2, pIntermedio = cvPoint(0,0);
		for(k=0;k<3;k++){
			pIntermedio.x = (pExtremo1.x + pExtremo2.x)/2;
			pIntermedio.y = (pExtremo1.y + pExtremo2.y)/2;
			i=pIntermedio.x;
			j=pIntermedio.y;
			//cvCircle( imgRetorno, pIntermedio, 3, CV_RGB(255,255,0), -1, 8,0);
			while(i>persona.min.x && i<persona.max.x && j>persona.min.y && j<persona.max.y){
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					break;
				}
				i++;
				j++;
			}
			pExtremo2.x=i;
			pExtremo2.y=j;
			i++;
			j--;
			while(i>persona.min.x && i<persona.max.x && j>persona.min.y && j<persona.max.y){//buscamos pExtremo1
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					break;
				}
				i++;
				j--;
			}
			pExtremo1.x=i;
			pExtremo1.y=j;

			i=pExtremo2.x + 1;
			j=pExtremo2.y - 1;

			while(i>persona.min.x && i<persona.max.x && j>persona.min.y && j<persona.max.y){//buscamos pExtremo2
				s=cvGet2D(imgGray,j,i);
				if(s.val[0]<220){
					break;
				}
				j++;
			}
			pExtremo2.x=i;
			pExtremo2.y=j;
		}

		CvPoint hombro1Superior = cvPoint((pExtremo1.x + pExtremo2.x)/2, (pExtremo1.y + pExtremo2.y)/2);
//--->aadir al caso 7
		if(persona.PVC[0].er.maxRel.size()==2){//comprobacion de que se ha colocado correctamente el hombro
			if(persona.PVC[0].er.minRel.size()==1){
				if(hombro1Superior.x - persona.min.x> persona.PVC[0].er.minRel[0]){
					hombro1Superior = persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]];
				}
			}else if(persona.PVC[0].er.minRel.size()==2){
				if(persona.PVC[0].er.minRel[0] < persona.PVC[0].er.maxRel[0]){
					if(hombro1Superior.x - persona.min.x> persona.PVC[0].er.maxRel[0]){
						double coeficienteCabeza = 0.0;
						coeficienteCabeza = persona.max.y - persona.min.y;
						hombro1Superior = persona.PVC[0].puntos[persona.PVC[0].er.maxRel[0] - coeficienteCabeza*0.15];
					}
				}
			}else if(persona.PVC[0].er.minRel.size()==3){
				if(persona.PVC[0].er.minRel[0] < persona.PVC[0].er.maxRel[0]){
					if(hombro1Superior.x - persona.min.x> persona.PVC[0].er.maxRel[0]){
						double coeficienteCabeza = 0.0;
						coeficienteCabeza = persona.max.y - persona.min.y;
						hombro1Superior = persona.PVC[0].puntos[persona.PVC[0].er.maxRel[0] - coeficienteCabeza*0.15];
					}
				}
			}
		}else if(persona.PVC[0].er.maxRel.size()==3){
			if(persona.PVC[0].er.minRel[0] > persona.PVC[0].er.maxRel[0]){
				if(hombro1Superior.x - persona.min.x> persona.PVC[0].er.minRel[0]){
					hombro1Superior = persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]];
				}
			}
		}

		CvPoint codo1Superior = cvPoint((hombro1Superior.x + mano1.x)/2, (hombro1Superior.y + mano1.y)/2);
		codo1Superior = persona.PVC[0].puntos[codo1Superior.x-persona.min.x];
		
		//cvCircle( imgRetorno, hombro1Superior, 3, CV_RGB(0,255,200), -1, 8,0);
		//cvCircle( imgRetorno, codo1Superior, 3, CV_RGB(255,255,0), -1, 8,0);

		
		int sinReferenciaHombro1=0;//0 si se puede sacar informacin de las proyecciones; cualquier otro valor si no se puede obtener informacin significativa
		if(persona.PHI[0].er.minRel.size()>0){
			hombro2Anterior= persona.PHI[0].puntos[persona.PHI[0].er.minRel.back()];//entendemos que el hombro sobresale del resto del cuerpo
			if(persona.PVC[0].er.maxRel.size()>1){
				for(i=0;i<persona.PVC[0].er.minRel.size();i++){
					if(hombro1Superior.x<persona.PVC[0].puntos[persona.PVC[0].er.minRel[i]].x){
						hombro2Anterior= persona.PVC[0].puntos[persona.PVC[0].er.minRel[i]];
						sinReferenciaHombro1=1;
						break;
					}
				}
			}
			//cvCircle( imgRetorno, hombro2Anterior, 3, CV_RGB(255,255,0), -1, 8,0);
		}else{
			sinReferenciaHombro1=-1;
		}
		
		/*Comprobamos que el primer hombro y codo son correctos*/
		double pendienteHombros = 0.0;

		//----------------------------------------------------------------------------------->>>>>>>>>>>>>>>>>>>>puede estar al reves esto
		if(sinReferenciaHombro1==0){//si hemos conseguido una buena referencia del hombro
			pendienteHombros = (hombro2Anterior.y - hombro1Superior.y);
			pendienteHombros = pendienteHombros /(hombro2Anterior.x - hombro1Superior.x);
		}
		if(sinReferenciaHombro1<0 || pendienteHombros > 0.4 || pendienteHombros<-1.5){
			hombro2Anterior = persona.PHI[0].puntos[hombro1Superior.y - persona.min.y];
			//cvCircle( imgRetorno, hombro2Anterior, 3, CV_RGB(0,255,200), -1, 8,0);

		}

		CvPoint codo2Anterior = persona.PHI[0].puntos[(hombro2Anterior.y + mano2.y - 2*persona.min.y)/2];//el punto medio entre la mano y el hombro
		
		CvPoint codo2Reverso = cvPoint((mano2.x + codo1Superior.x)/2,codo2Anterior.y);
		
		
		//ahora calcular el punto medio del codo
		CvPoint codo2=cvPoint((codo2Anterior.x+codo2Reverso.x)/2,(codo2Anterior.y+codo2Reverso.y)/2);
		CvPoint hombro2=cvPoint(hombro2Anterior.x+(codo2.x-codo2Anterior.x), hombro2Anterior.y);
		if(sinReferenciaHombro1==1){
			hombro2.x=hombro2Anterior.x;
			hombro2.y=hombro2Anterior.y;
		}
		
		//calculamos los extremos inferiores del codo del brazo de la derecha
		for(i=persona.max.y; i>persona.min.y; i--){//primero el codo//----------------------------------------->ojo creo que he corregido aqui un error con el i--
			s=cvGet2D(imgGray,i,codo1Superior.x);
			if(s.val[0]<220){
				break;
			}
		}
		CvPoint codo1Inferior=cvPoint(codo1Superior.x, i);
		CvPoint codo1=cvPoint((codo1Inferior.x+codo1Superior.x)/2,(codo1Inferior.y+codo1Superior.y)/2);
		//calculamos los extremos inferiores del hombro del brazo de la derecha
		for(i=persona.max.y; i>persona.min.y; i--){//primero el codo//----------------------------------------->ojo creo que he corregido aqui un error con el i--
			s=cvGet2D(imgGray,i,hombro1Superior.x + 10);
			if(s.val[0]<220){
				break;
			}
		}
		CvPoint hombro1Inferior=cvPoint(hombro1Superior.x, i);
		CvPoint hombro1=cvPoint((hombro1Inferior.x+hombro1Superior.x)/2,(hombro1Inferior.y+hombro1Superior.y)/2);
		if((codo1.y - codo1Superior.y) < (hombro1.y - hombro1Superior.y)){//si la diferencia es muy grande, debe ser porque el extremo inferior del hombro no est bien cogido
			hombro1.y=hombro1Superior.y +(codo1.y - codo1Superior.y);
		}
		cvCircle( imgRetorno, mano1, 3, CV_RGB(255,0,0), -1, 8,0);
		cvCircle( imgRetorno, hombro1, 3, CV_RGB(120,0,0), -1, 8,0);
		cvCircle( imgRetorno, mano2, 3, CV_RGB(0,0,255), -1, 8,0);
		cvCircle( imgRetorno, hombro2, 3, CV_RGB(0,0,120), -1, 8,0);

		brazos.clear();
		brazos.push_back(mano1);
		brazos.push_back(codo1);
		brazos.push_back(hombro1);
		brazos.push_back(mano2);
		brazos.push_back(codo2);
		brazos.push_back(hombro2);

		persona.brazo1.clear();
		persona.brazo1.push_back(brazos[0]);
		persona.brazo1.push_back(brazos[1]);
		persona.brazo1.push_back(brazos[2]);
		persona.brazo2.clear();
		persona.brazo2.push_back(brazos[3]);
		persona.brazo2.push_back(brazos[4]);
		persona.brazo2.push_back(brazos[5]);

		//fin if caso 8

	}
	
	
	return brazos;
}


void AnalisisPersona::dibujarCuerpoHumano(){
	int i;
	//cvRectangle( imgRetorno, persona.min, persona.max, CV_RGB(255,0,0), 3, 8, 0 );

	/*Dibujar cabeza*/
	CvPoint pt1, pt2;
	pt1.x = persona.cabeza.x;
    pt2.x = (persona.cabeza.x+persona.cabeza.width);
    pt1.y = persona.cabeza.y;
    pt2.y = (persona.cabeza.y+persona.cabeza.height);
	cvRectangle( imgRetorno, pt1, pt2, CV_RGB(0,255,0), 2/*delgadez*/, 8, 0 );

	/*Dibujar brazos*/
	if(persona.brazo1.size()>2){
		cvLine(imgRetorno,persona.brazo1[0],persona.brazo1[1], CV_RGB(0,255,0),2,8,0);//antebrazo izquierdo
		cvLine(imgRetorno,persona.brazo1[1],persona.brazo1[2], CV_RGB(0,255,0),2,8,0);//brazo izquierdo
	}
	if(persona.brazo2.size()>2){
		cvLine(imgRetorno,persona.brazo2[0],persona.brazo2[1], CV_RGB(0,255,0),2,8,0);//antebrazo izquierdo
		cvLine(imgRetorno,persona.brazo2[1],persona.brazo2[2], CV_RGB(0,255,0),2,8,0);//brazo izquierdo
	}
	/*Dibujar cuello*/
	if(persona.cuello.size()>1){
		cvLine(imgRetorno,persona.cuello[0],persona.cuello[1], CV_RGB(0,255,0),3,8,0);//antebrazo izquierdo
	}
	/*Dibujar hombros*/
	if(persona.hombros.size()>1){
		cvLine(imgRetorno,persona.hombros[0],persona.hombros[1], CV_RGB(0,255,0),3,8,0);//antebrazo izquierdo
	}
	/*Dibujar columna*/
	if(persona.columnaVertebral.size()>1){
		for(i=1;i<persona.columnaVertebral.size();i++){
			cvLine(imgRetorno,persona.columnaVertebral[i-1],persona.columnaVertebral[i], CV_RGB(0,255,0),3,8,0);
		}
	}
	/*Dibujar cadera*/
	if(persona.cadera.size()>1){
		for(i=1;i<persona.cadera.size();i++){
			cvLine(imgRetorno,persona.cadera[i-1],persona.cadera[i], CV_RGB(0,255,0),3,8,0);
		}
	}
	/*Dibujar pierna1*/
	if(persona.pierna1.size()>1){
		for(i=1;i<persona.pierna1.size();i++){
			cvLine(imgRetorno,persona.pierna1[i-1],persona.pierna1[i], CV_RGB(0,255,0),2,8,0);
		}
	}
	/*Dibujar pierna2*/
	if(persona.pierna2.size()>1){
		for(i=1;i<persona.pierna2.size();i++){
			cvLine(imgRetorno,persona.pierna2[i-1],persona.pierna2[i], CV_RGB(0,255,0),2,8,0);
		}
	}
}

void AnalisisPersona::hallarProyecciones(){
	int i=0, i2=0, j=0, j2=0, k=0;
	vector<CvPoint> indicesFusionHDVC, indicesFusionHIVC, indicesFusionHDVCAux;//uso el tipo cvpoint aprovechando que es una estructura de dos int
	CvScalar s;
	CvPoint dot,prevDot;
	dot.x=0;
	dot.y=0;
	prevDot.x=0;
	prevDot.y=0;
	listaPHDLPuntos.clear();//lista con la proyeccion horizontal derecha de lineas de puntos
	listaPVCLPuntos.clear();//lista con la proyeccion vertical en caida de lineas de puntos
	listaPHILPuntos.clear();
	listaPDDLPuntos.clear();
	listaPDILPuntos.clear();
	listaProyeccionesCuerpo.clear();

	vector<int> numeroPixelsNegrosFila(imgGray->height,0);
	vector<int> numeroPixelsNegrosColumna(imgGray->width,0);
	/*Localizamos la region donde probablemente este el cuerpo de la persona
	  Primero hacemos una cuenta de los elementos blancos y negros por filas y columnas*/

	
	for(j=10;j<imgGray->width;j++){//recorremos cada columa
		for(i=10;i<imgGray->height;i++){//recorremos cada fila
			s=cvGet2D(imgGray,i,j);//obtenemos el valor del pixel fila i, columna j
			if(s.val[0]<220){
				numeroPixelsNegrosFila[i]++;
				int vali = suelo.y;
				if(suelo.y<0 || i<suelo.y){//si hay informacion sobre la localizacion del suelo
					numeroPixelsNegrosColumna[j]++;
				}
			}
		}
	}
	ExtremosRelativos erFilas=calcularExtremosRelativos(numeroPixelsNegrosFila, 60, 1, 5);//a 60//a 120
	ExtremosRelativos erColumnas=calcularExtremosRelativos(numeroPixelsNegrosColumna, 60,1, 5);//a 60//a 150
	//for(i=00;i<erFilas.maxRel.size();i++){//recorremos cada fila
	//	cvCircle( imgRetorno, cvPoint(10, erFilas.maxRel[i]), 3, CV_RGB(255,0,0), -1, 8,0);
	//}
	//for(i=00;i<erFilas.minRel.size();i++){//recorremos cada fila
	//	cvCircle( imgRetorno, cvPoint(10, erFilas.minRel[i]), 3, CV_RGB(0,255,0), -1, 8,0);
	//}
	//for(i=0;i<erColumnas.maxRel.size();i++){//recorremos cada fila
	//	cvCircle( imgRetorno, cvPoint(erColumnas.maxRel[i], 10), 3, CV_RGB(255,0,0), -1, 8,0);
	//}
	//for(i=0;i<erColumnas.minRel.size();i++){//recorremos cada fila
	//	cvCircle( imgRetorno, cvPoint(erColumnas.minRel[i], 10), 3, CV_RGB(0,255,0), -1, 8,0);
	//}

	suelo = localizarSuelo(numeroPixelsNegrosFila, numeroPixelsNegrosColumna, erFilas, erColumnas);
	
	CvRect areaPersona = localizarCuerpo(numeroPixelsNegrosFila, numeroPixelsNegrosColumna, erFilas, erColumnas);
	CvPoint pt1 = cvPoint(areaPersona.x, areaPersona.y);
	CvPoint pt2 = cvPoint(areaPersona.x+areaPersona.width, areaPersona.y+areaPersona.height);


	/*Calculo por filtros de compas*/
		/*Primer recorrido - por cada fila, de izquierda a derecha*/
	for(i=pt1.y;i<pt2.y;i++){//recorremos cada fila
		for(j=pt1.x;j<pt2.x;j++){//recorremos cada columa de cada fila
			s=cvGet2D(imgGray,i,j);//obtenemos el valor del pixel fila i, columna j
			if(s.val[0]<220){
				prevDot=dot;
				dot.x=j;
				dot.y=i;
				//cvCircle( frame, dot, 3, CV_RGB(0,255,0), -1, 8,0);
				if((listaPHDLPuntos.size()<=0)/* ||((abs(prevDot.x-dot.x)^2 + abs(prevDot.y-dot.y)^2)>opciones->umbralDistanciaPuntosDCH)*/){
					ProyeccionLineaPuntos plp;
					plp.puntos.push_back(dot);
					plp.min=cvPoint(opciones->getTamImagen().width,opciones->getTamImagen().height);//inicializacion por defecto
					plp.max=cvPoint(0,0);//inicializacion por defecto
					listaPHDLPuntos.push_back(plp);
				}else{
					listaPHDLPuntos[listaPHDLPuntos.size()-1].puntos.push_back(dot);
				}
				break;//saltamos a la siguiente linea
			}
		}
	}
	for(j=0;j<listaPHDLPuntos[0].puntos.size();j++){
		dot=listaPHDLPuntos[0].puntos[j];
		if(listaPHDLPuntos[0].min.x > dot.x)
			listaPHDLPuntos[0].min.x = dot.x;
		if(listaPHDLPuntos[0].min.y > dot.y)
			listaPHDLPuntos[0].min.y = dot.y;
		if(listaPHDLPuntos[0].max.x < dot.x)
			listaPHDLPuntos[0].max.x = dot.x;
		if(listaPHDLPuntos[0].max.y < dot.y)
			listaPHDLPuntos[0].max.y = dot.y;
		//cvCircle( imgRetorno, dot, 3, CV_RGB(0,255,0), -1, 8,0);
	}
	dot.x=0;
	dot.y=0;
	prevDot.x=0;
	prevDot.y=0;

	if(persona.PHD.size()<=0){
		persona.PHD.push_back(listaPHDLPuntos[0]);
	}else{
		persona.PHD[0]=listaPHDLPuntos[0];//copiamos los datos temporales a la estructura general de la clase
	}

	//para colorear los vectores de proyecciones
/*	for(i=0;i<listaPHDLPuntos.size();i++){
		for(i2=0;i2<listaPHDLPuntos[i].puntos.size();i2++){
			dot=listaPHDLPuntos[i].puntos[i2];
			if(i==0 || i==2 || i==4){
				cvCircle( imgRetorno, dot, 3, CV_RGB(255,0,0), -1, 8,0);
			}else{
				cvCircle( imgRetorno, dot, 3, CV_RGB(0,0,255), -1, 8,0);
			}
		}
	}
*/	
	/*Segundo recorrido - por cada columna, de arriba a abajo*/
	for(j=pt1.x;j<pt2.x;j++){//recorremos cada columa de cada fila
		for(i=pt1.y;i<pt2.y;i++){//recorremos cada fila
			s=cvGet2D(imgGray,i,j);//obtenemos el valor del pixel fila i, columna j
			if(s.val[0]<220){
				prevDot=dot;
				dot.x=j;
				dot.y=i;
				//cvCircle( frame, dot, 3, CV_RGB(0,255,0), -1, 8,0);
				if((listaPVCLPuntos.size()<=0)/* || ((abs(prevDot.x-dot.x)^2 + abs(prevDot.y-dot.y)^2)>opciones->umbralDistanciaPuntosDCH)*/){
					ProyeccionLineaPuntos plp;
					plp.puntos.push_back(dot);
					plp.min=cvPoint(opciones->getTamImagen().width,opciones->getTamImagen().height);//inicializacion por defecto
					plp.max=cvPoint(0,0);//inicializacion por defecto
					listaPVCLPuntos.push_back(plp);
				}else{
					listaPVCLPuntos[listaPVCLPuntos.size()-1].puntos.push_back(dot);
				}
				break;//saltamos a la siguiente linea (solo si la imagen est filtrada casi por completo
			}
		}
	}
	for(i=0;i<listaPVCLPuntos.size();i++){
		if(listaPVCLPuntos[i].puntos.size()>30){//el 15 es el numero de puntos consecutivos a partir del cual consideramos que eso hay que mantenerlo en representacin
			for(j=0;j<listaPVCLPuntos[i].puntos.size();j++){
				dot=listaPVCLPuntos[i].puntos[j];
				if(listaPVCLPuntos[i].min.x > dot.x)
					listaPVCLPuntos[i].min.x = dot.x;
				if(listaPVCLPuntos[i].min.y > dot.y)
					listaPVCLPuntos[i].min.y = dot.y;
				if(listaPVCLPuntos[i].max.x < dot.x)
					listaPVCLPuntos[i].max.x = dot.x;
				if(listaPVCLPuntos[i].max.y < dot.y)
					listaPVCLPuntos[i].max.y = dot.y;
				//cvCircle( imgRetorno, dot, 3, CV_RGB(255,0,0), -1, 8,0);
			}
		}else{
			listaPVCLPuntos.erase(listaPVCLPuntos.begin()+i);
			i--;
		}
	}
	dot.x=0;
	dot.y=0;
	prevDot.x=0;
	prevDot.y=0;

	if(persona.PVC.size()<=0){
		persona.PVC.push_back(listaPVCLPuntos[0]);
	}else{
		persona.PVC[0]=listaPVCLPuntos[0];
	}

	//para colorear los vectores de proyecciones
/*	for(i=0;i<listaPVCLPuntos.size();i++){
		for(i2=0;i2<listaPVCLPuntos[i].puntos.size();i2++){
			dot=listaPVCLPuntos[i].puntos[i2];
			if(i==0 || i==2 || i==4){
				cvCircle( imgRetorno, dot, 3, CV_RGB(255,0,0), -1, 8,0);
			}else{
				cvCircle( imgRetorno, dot, 3, CV_RGB(0,0,255), -1, 8,0);
			}
		}
	}
*/
	/*Tercer recorrido - por cada fila, de derecha a izquierda*/
	
	for(i=pt1.y; i < pt2.y;i++){//recorremos cada fila
		for(j=pt2.x-1;j>pt1.x;j--){//recorremos cada columa de cada fila
			s=cvGet2D(imgGray,i,j);//obtenemos el valor del pixel fila i, columna j
			if(s.val[0]<220){
				prevDot=dot;
				dot.x=j;
				dot.y=i;
				//cvCircle( frame, dot, 3, CV_RGB(0,255,0), -1, 8,0);
				if((listaPHILPuntos.size()<=0)/* || ((abs(prevDot.x-dot.x)^2 + abs(prevDot.y-dot.y)^2)>opciones->umbralDistanciaPuntosDCH)*/){
					ProyeccionLineaPuntos plp;
					plp.puntos.push_back(dot);
					plp.min=cvPoint(opciones->getTamImagen().width,opciones->getTamImagen().height);//inicializacion por defecto
					plp.max=cvPoint(0,0);//inicializacion por defecto
					listaPHILPuntos.push_back(plp);
				}else{
					listaPHILPuntos[listaPHILPuntos.size()-1].puntos.push_back(dot);
				}
				break;//saltamos a la siguiente linea (solo si la imagen est filtrada casi por completo
			}
		}
	}
	
	for(j=0;j<listaPHILPuntos[0].puntos.size();j++){
		dot=listaPHILPuntos[0].puntos[j];
		if(listaPHILPuntos[0].min.x > dot.x)
			listaPHILPuntos[0].min.x = dot.x;
		if(listaPHILPuntos[0].min.y > dot.y)
			listaPHILPuntos[0].min.y = dot.y;
		if(listaPHILPuntos[0].max.x < dot.x)
			listaPHILPuntos[0].max.x = dot.x;
		if(listaPHILPuntos[0].max.y < dot.y)
			listaPHILPuntos[0].max.y = dot.y;
		//cvCircle( imgRetorno, dot, 3, CV_RGB(255,0,0), -1, 8,0);
	}
	dot.x=0;
	dot.y=0;
	prevDot.x=0;
	prevDot.y=0;
	
	if(persona.PHI.size()<=0){
		persona.PHI.push_back(listaPHILPuntos[0]);
	}else{
		persona.PHI[0]=listaPHILPuntos[0];
	}

	//para colorear los vectores de proyecciones
/*	for(i=0;i<listaPHILPuntos.size();i++){
		for(i2=0;i2<listaPHILPuntos[i].puntos.size();i2++){
			dot=listaPHILPuntos[i].puntos[i2];
			if(i==0 || i==2 || i==4){
				cvCircle( imgRetorno, dot, 3, CV_RGB(255,0,0), -1, 8,0);
			}else{
				cvCircle( imgRetorno, dot, 3, CV_RGB(0,0,255), -1, 8,0);
			}
		}
	}
/**/
	
	/*Cuarto recorrido - en diagonal hacia abajo, de izquierda a derecha*/
	/*divido en dos partes el recorrido*/
	int jIter, iIter;
	for(iIter=pt2.y;iIter>pt1.y;iIter--){//recorremos cada fila
		i=iIter;
		int bandera=-1;//-1 no se ha encontrado ningun elemento en esa iteracion
		for(j=pt1.x;j<pt2.x && i<pt2.y;j++){//recorremos cada columa de cada fila
			s=cvGet2D(imgGray,i,j);//obtenemos el valor del pixel fila i, columna j
			if(s.val[0]<220){
				prevDot=dot;
				dot.x=j;
				dot.y=i;
				//cvCircle( frame, dot, 3, CV_RGB(0,255,0), -1, 8,0);
				if((listaPDDLPuntos.size()<=0)/* ||((abs(prevDot.x-dot.x)^2 + abs(prevDot.y-dot.y)^2)>opciones->umbralDistanciaPuntosDCH)*/){
					ProyeccionLineaPuntos plp;
					plp.puntos.push_back(dot);
					plp.min=cvPoint(opciones->getTamImagen().width,opciones->getTamImagen().height);//inicializacion por defecto
					plp.max=cvPoint(0,0);//inicializacion por defecto
					listaPDDLPuntos.push_back(plp);
				}else{
					listaPDDLPuntos[listaPDDLPuntos.size()-1].puntos.push_back(dot);
				}
				bandera=0;
				break;//saltamos a la siguiente linea
			}
			i++;
		}
		if(bandera!=0){
			dot.x=j;
			dot.y=i;
			if((listaPDDLPuntos.size()<=0)/* ||((abs(prevDot.x-dot.x)^2 + abs(prevDot.y-dot.y)^2)>opciones->umbralDistanciaPuntosDCH)*/){
				ProyeccionLineaPuntos plp;
				plp.puntos.push_back(dot);
				plp.min=cvPoint(opciones->getTamImagen().width,opciones->getTamImagen().height);//inicializacion por defecto
				plp.max=cvPoint(0,0);//inicializacion por defecto
				listaPDDLPuntos.push_back(plp);
			}else{
				listaPDDLPuntos[listaPDDLPuntos.size()-1].puntos.push_back(dot);
			}
		}
	}
	for(jIter=pt1.x;jIter<pt2.x;jIter++){//recorremos cada columa de cada fila
		j=jIter;
		int bandera=-1;//-1 no se ha encontrado ningun elemento en esa iteracion
		for(i=pt1.y;j<pt2.x && i<pt2.y;i++){//recorremos cada fila
			s=cvGet2D(imgGray,i,j);//obtenemos el valor del pixel fila i, columna j
			if(s.val[0]<220){
				prevDot=dot;
				dot.x=j;
				dot.y=i;
				//cvCircle( frame, dot, 3, CV_RGB(0,255,0), -1, 8,0);
				if((listaPDDLPuntos.size()<=0)/* ||((abs(prevDot.x-dot.x)^2 + abs(prevDot.y-dot.y)^2)>opciones->umbralDistanciaPuntosDCH)*/){
					ProyeccionLineaPuntos plp;
					plp.puntos.push_back(dot);
					plp.min=cvPoint(opciones->getTamImagen().width,opciones->getTamImagen().height);//inicializacion por defecto
					plp.max=cvPoint(0,0);//inicializacion por defecto
					listaPDDLPuntos.push_back(plp);
				}else{
					listaPDDLPuntos[listaPDDLPuntos.size()-1].puntos.push_back(dot);
				}
				bandera=0;
				break;//saltamos a la siguiente linea
			}
			j++;
		}
		if(bandera!=0){
			dot.x=j;
			dot.y=i;
			if((listaPDDLPuntos.size()<=0)/* ||((abs(prevDot.x-dot.x)^2 + abs(prevDot.y-dot.y)^2)>opciones->umbralDistanciaPuntosDCH)*/){
				ProyeccionLineaPuntos plp;
				plp.puntos.push_back(dot);
				plp.min=cvPoint(opciones->getTamImagen().width,opciones->getTamImagen().height);//inicializacion por defecto
				plp.max=cvPoint(0,0);//inicializacion por defecto
				listaPDDLPuntos.push_back(plp);
			}else{
				listaPDDLPuntos[listaPDDLPuntos.size()-1].puntos.push_back(dot);
			}
		}
	}
	for(j=0;j<listaPDDLPuntos[0].puntos.size();j++){
		dot=listaPDDLPuntos[0].puntos[j];
		if(listaPDDLPuntos[0].min.x > dot.x)
			listaPDDLPuntos[0].min.x = dot.x;
		if(listaPDDLPuntos[0].min.y > dot.y)
			listaPDDLPuntos[0].min.y = dot.y;
		if(listaPDDLPuntos[0].max.x < dot.x)
			listaPDDLPuntos[0].max.x = dot.x;
		if(listaPDDLPuntos[0].max.y < dot.y)
			listaPDDLPuntos[0].max.y = dot.y;
//		cvCircle( imgRetorno, dot, 3, CV_RGB(0,255,0), -1, 8,0);
	}
	dot.x=0;
	dot.y=0;
	prevDot.x=0;
	prevDot.y=0;

	if(persona.PDD.size()<=0){
		persona.PDD.push_back(listaPDDLPuntos[0]);
	}else{
		persona.PDD[0]=listaPDDLPuntos[0];//copiamos los datos temporales a la estructura general de la clase
	}


	/*Quinto recorrido - en diagonal hacia abajo, de derecha a izquierda*/
	/*divido en dos partes el recorrido*/
	for(jIter=pt1.x;jIter<pt2.x;jIter++){//recorremos cada columa de cada fila
		j=jIter;
		int bandera=-1;//-1 no se ha encontrado ningun elemento en esa iteracion
		for(i=pt1.y;i<pt2.y && j>=pt1.x;i++){//recorremos cada fila
			s=cvGet2D(imgGray,i,j);//obtenemos el valor del pixel fila i, columna j
			if(s.val[0]<220){
				prevDot=dot;
				dot.x=j;
				dot.y=i;
//				cvCircle( imgRetorno, dot, 3, CV_RGB(255,0,0), -1, 8,0);
				if((listaPDILPuntos.size()<=0)/* ||((abs(prevDot.x-dot.x)^2 + abs(prevDot.y-dot.y)^2)>opciones->umbralDistanciaPuntosDCH)*/){
					ProyeccionLineaPuntos plp;
					plp.puntos.push_back(dot);
					plp.min=cvPoint(opciones->getTamImagen().width,opciones->getTamImagen().height);//inicializacion por defecto
					plp.max=cvPoint(0,0);//inicializacion por defecto
					listaPDILPuntos.push_back(plp);
				}else{
					listaPDILPuntos[listaPDILPuntos.size()-1].puntos.push_back(dot);
				}
				bandera=0;
				break;//saltamos a la siguiente linea
			}
			j--;
		}
		if(bandera!=0){
			dot.x=j;
			dot.y=i;
			if((listaPDILPuntos.size()<=0)/* ||((abs(prevDot.x-dot.x)^2 + abs(prevDot.y-dot.y)^2)>opciones->umbralDistanciaPuntosDCH)*/){
				ProyeccionLineaPuntos plp;
				plp.puntos.push_back(dot);
				plp.min=cvPoint(opciones->getTamImagen().width,opciones->getTamImagen().height);//inicializacion por defecto
				plp.max=cvPoint(0,0);//inicializacion por defecto
				listaPDILPuntos.push_back(plp);
			}else{
				listaPDILPuntos[listaPDILPuntos.size()-1].puntos.push_back(dot);
			}
		}
	}

	for(iIter=pt1.y;iIter<pt2.y;iIter++){//recorremos cada fila
		i=iIter;
		int bandera=-1;//-1 no se ha encontrado ningun elemento en esa iteracion
		for(j=pt2.x;i<pt2.y && j>=pt1.x;j--){//recorremos cada columa de cada fila
			s=cvGet2D(imgGray,i,j);//obtenemos el valor del pixel fila i, columna j
			
			if(s.val[0]<220){
				prevDot=dot;
				dot.x=j;
				dot.y=i;
//				cvCircle( imgRetorno, dot, 3, CV_RGB(255,0,0), -1, 8,0);
				if((listaPDILPuntos.size()<=0)/* ||((abs(prevDot.x-dot.x)^2 + abs(prevDot.y-dot.y)^2)>opciones->umbralDistanciaPuntosDCH)*/){
					ProyeccionLineaPuntos plp;
					plp.puntos.push_back(dot);
					plp.min=cvPoint(opciones->getTamImagen().width,opciones->getTamImagen().height);//inicializacion por defecto
					plp.max=cvPoint(0,0);//inicializacion por defecto
					listaPDILPuntos.push_back(plp);
				}else{
					listaPDILPuntos[listaPDILPuntos.size()-1].puntos.push_back(dot);
				}
				bandera=0;
				break;//saltamos a la siguiente linea
			}
			i++;
		}
		if(bandera!=0){
			dot.x=j;
			dot.y=i;
			if((listaPDILPuntos.size()<=0)/* ||((abs(prevDot.x-dot.x)^2 + abs(prevDot.y-dot.y)^2)>opciones->umbralDistanciaPuntosDCH)*/){
				ProyeccionLineaPuntos plp;
				plp.puntos.push_back(dot);
				plp.min=cvPoint(opciones->getTamImagen().width,opciones->getTamImagen().height);//inicializacion por defecto
				plp.max=cvPoint(0,0);//inicializacion por defecto
				listaPDILPuntos.push_back(plp);
			}else{
				listaPDILPuntos[listaPDILPuntos.size()-1].puntos.push_back(dot);
			}
		}
	}



	for(j=0;j<listaPDILPuntos[0].puntos.size();j++){
		dot=listaPDILPuntos[0].puntos[j];
		if(listaPDILPuntos[0].min.x > dot.x)
			listaPDILPuntos[0].min.x = dot.x;
		if(listaPDILPuntos[0].min.y > dot.y)
			listaPDILPuntos[0].min.y = dot.y;
		if(listaPDILPuntos[0].max.x < dot.x)
			listaPDILPuntos[0].max.x = dot.x;
		if(listaPDILPuntos[0].max.y < dot.y)
			listaPDILPuntos[0].max.y = dot.y;
//		cvCircle( imgRetorno, dot, 3, CV_RGB(0,255,0), -1, 8,0);
	}
	dot.x=0;
	dot.y=0;
	prevDot.x=0;
	prevDot.y=0;
	if(persona.PDI.size()<=0){
		persona.PDI.push_back(listaPDILPuntos[0]);
	}else{
		persona.PDI[0]=listaPDILPuntos[0];//copiamos los datos temporales a la estructura general de la clase
	}


	/*Rellenar los huecos del las proyecciones*/
	int anterior=0;
	for(i=1;i<persona.PHD[0].puntos.size();i++){
		if(persona.PHD[0].puntos[i].y-persona.PHD[0].puntos[i-1].y >1){//si hay un salto
			int p1=persona.PHD[0].puntos[i].y;
			int p2=persona.PHD[0].puntos[i-1].y;
			anterior=i;
			int paso = (persona.PHD[0].puntos[i].x-persona.PHD[0].puntos[i-1].x) / (persona.PHD[0].puntos[i].y-persona.PHD[0].puntos[i-1].y);
				//primero asignar el valor de los puntos a otro lado para luego pegarlos
			int nveces=p1-p2;//debera restar 1 pero ya lo hago en el bucle
			i--;
			for(j=1;j<nveces;j++){//interpolacion de orden 1 para completar huecos
				CvPoint punto;
				punto.x = persona.PHD[0].puntos[i].x + paso*j;
				punto.y = persona.PHD[0].puntos[0].y + i + j;
				persona.PHD[0].puntos.insert(  persona.PHD[0].puntos.begin() + i+j, punto);				
			}
			//i = i + persona.PHD[0].puntos[i].y - persona.PHD[0].puntos[i-1].y;
			i+=nveces;
		}
	}//fin for
	for(i=1;i<persona.PVC[0].puntos.size();i++){

		if(persona.PVC[0].puntos[i].x-persona.PVC[0].puntos[i-1].x >1){//si hay un salto
			int p1=persona.PVC[0].puntos[i].x;
			int p2=persona.PVC[0].puntos[i-1].x;
			anterior=i;
			int paso = (persona.PVC[0].puntos[i].y-persona.PVC[0].puntos[i-1].y) / (persona.PVC[0].puntos[i].x-persona.PVC[0].puntos[i-1].x);
				//primero asignar el valor de los puntos a otro lado para luego pegarlos
			int nveces=p1-p2;
			i--;
			for(j=1;j<nveces;j++){//interpolacion de orden 1 para completar huecos
				CvPoint punto;
				punto.y = persona.PVC[0].puntos[i].y + paso*(j);
				punto.x = persona.PVC[0].puntos[0].x + i + j;
				persona.PVC[0].puntos.insert(  persona.PVC[0].puntos.begin() + i+j, punto);
			}
			//i = i + persona.PVC[0].puntos[i].x - persona.PVC[0].puntos[i-1].x;
			i+=nveces;
		}
	}//fin for
	for(i=1;i<persona.PHI[0].puntos.size();i++){
		if(persona.PHI[0].puntos[i].y-persona.PHI[0].puntos[i-1].y >1){//si hay un salto
			int p1=persona.PHI[0].puntos[i].y;
			int p2=persona.PHI[0].puntos[i-1].y;
			anterior=i;
			int paso = (persona.PHI[0].puntos[i].x-persona.PHI[0].puntos[i-1].x) / (persona.PHI[0].puntos[i].y-persona.PHI[0].puntos[i-1].y);
				//primero asignar el valor de los puntos a otro lado para luego pegarlos
			int nveces=p1-p2;
			i--;
			for(j=1;j<nveces;j++){//interpolacion de orden 1 para completar huecos
				CvPoint punto;
				punto.x = persona.PHI[0].puntos[i].x + paso*j;
				punto.y = persona.PHI[0].puntos[0].y + i + j;
				persona.PHI[0].puntos.insert(  persona.PHI[0].puntos.begin() + i+j, punto);
			}
			//i = i + persona.PHI[0].puntos[i].y - persona.PHI[0].puntos[i-1].y;
			i+=nveces;
		}
	}//fin for

	//ajustamos los extremos
	persona.min.x=persona.PVC[0].puntos[0].x;
	persona.min.y=persona.PHD[0].puntos[0].y;
	persona.max.x=persona.PVC[0].puntos.back().x;
	persona.max.y=persona.PHD[0].puntos.back().y;



	vector<int> listaDatosPDD;
	vector<int> listaDatosPDI;
	/*Detectamos extremos relativos en la proyeccin lateral derecha (de izquierda a derecha)*/
	persona.PHD[0].er=calcularExtremosRelativos(persona.PHD[0].puntos, 30, 40, 3, 1);//antes estaba a 40	
	/*Detectamos extremos relativos en la proyeccin vertical superior*/
	persona.PVC[0].er=calcularExtremosRelativos(persona.PVC[0].puntos, 20, 1, 3, 0);
	/*Detectamos extremos relativos en la proyeccin lateral izquierda (de derecha a izquierda)*/
	persona.PHI[0].er=calcularExtremosRelativos(persona.PHI[0].puntos, 30, 40, 3, 1);
	if(persona.PHI[0].er.minRel.size()>2){
		persona.PHI[0].er=calcularExtremosRelativos(persona.PHI[0].puntos, 30, 0, 0, 1);
	}
	for(i=0;i<persona.PDD[0].puntos.size();i++){//convertimos los valores para que tengan sentido sus funciones (al ser diagonales, el crecimiento de la funcin depende de las dos variables, x e y)
		listaDatosPDD.push_back( -persona.PDD[0].puntos[i].x - persona.PDD[0].puntos[i].y);
	}
	for(i=0;i<persona.PDI[0].puntos.size();i++){//convertimos los valores para que tengan sentido sus funciones (al ser diagonales, el crecimiento de la funcin depende de las dos variables, x e y)
		listaDatosPDI.push_back( persona.PDI[0].puntos[i].x - persona.PDI[0].puntos[i].y);
	}
	/*Detectamos extremos relativos en la proyeccin diagonal derecha descendente (de izquierda a izquierda)*/
	persona.PDD[0].er=calcularExtremosRelativos(listaDatosPDD, 20, 5, 3);
	/*Detectamos extremos relativos en la proyeccin diagonal izquierda descendente (de derecha a izquierda)*/
	persona.PDI[0].er=calcularExtremosRelativos(listaDatosPDI, 20, 5, 3);



	//eliminamos aquellos que sean sospechosos
	if((casoPrev<5 && casoPrev>0) || casoPrev==6){
		//if(persona.PHD[0].er.maxRel[0]>persona.PHD[0].er.minRel[0]){//para asegurarnos que los brazos estn bajados y no afectan negativamente a este calculo
			for(i=0;i<persona.PHD[0].er.minRel.size();i++){
				if(i>=persona.PHD[0].er.minRel.size()){
					break;
				}
				if(persona.PHD[0].puntos[persona.PHD[0].er.minRel[i]].x > (persona.max.x+persona.min.x)/2 /*persona.PHD[0].puntos[persona.PHD[0].er.minRel[0]].x*/){
					//borrar el elemento y tambin borrar el siguiente max rel
					persona.PHD[0].er.minRel.erase(persona.PHD[0].er.minRel.begin()+i);
					if(persona.PHD[0].er.minRel.size()>0){
						if(persona.PHD[0].er.maxRel[0]<persona.PHD[0].er.minRel[0]){
							if(persona.PHD[0].er.maxRel.size()>i+1){
								persona.PHD[0].er.maxRel.erase(persona.PHD[0].er.maxRel.begin()+i+1);
							}
						}else{
							if(persona.PHD[0].er.maxRel.size()>i){
								persona.PHD[0].er.maxRel.erase(persona.PHD[0].er.maxRel.begin()+i);
							}
						}
					}else{
						if(persona.PHD[0].er.maxRel.size()>i+1){
							persona.PHD[0].er.maxRel.erase(persona.PHD[0].er.maxRel.begin()+i+1);
						}
					}
				}
			}
		//}
	}
	if((casoPrev<5 && casoPrev>0) || casoPrev==5){
		//repetir esto para phi
		if(persona.PHI[0].er.minRel[0]>persona.PHI[0].er.maxRel[0]){//para asegurarnos que los brazos estn bajados y no afectan negativamente a este calculo
			for(i=1;i<persona.PHI[0].er.maxRel.size();i++){
				if(persona.PHI[0].puntos[persona.PHI[0].er.maxRel[i]].x < persona.PHI[0].puntos[persona.PHI[0].er.maxRel[0]].x){
					//borrar el elemento y tambin borrar el siguiente max rel
					persona.PHI[0].er.maxRel.erase(persona.PHI[0].er.maxRel.begin()+i);
					if(persona.PHI[0].er.minRel[0]<persona.PHI[0].er.maxRel[0]){
						if(persona.PHI[0].er.minRel.size()>i+1){
							persona.PHI[0].er.minRel.erase(persona.PHI[0].er.minRel.begin()+i+1);
						}
					}else{
						if(persona.PHI[0].er.minRel.size()>i){
							persona.PHI[0].er.minRel.erase(persona.PHI[0].er.minRel.begin()+i);
						}
					}
				}
			}
		}
	}


}

vector<CvPoint> AnalisisPersona::detectarCuello_HombrosConociendoCabeza(CvRect areaReducida){
	vector<CvPoint> cuello_hombros;//dos primeros puntos corresponden a la linea del esqueleto del cuello y los otros dos corresponden a la linea del hombro que sern enviados como solucin
	int i;
	for(i=0;i<4;i++){//inicializamoss el vector con cuatro elementos cuyo valor es (0,0)
		cuello_hombros.push_back(cvPoint(0,0));
	}
	
    CvPoint pt1, pt2;
	pt1.x = areaReducida.x;
    pt2.x = (areaReducida.x+areaReducida.width);
    pt1.y = areaReducida.y;
    pt2.y = (areaReducida.y+areaReducida.height);
	//cvRectangle( imgRetorno, pt1, pt2, CV_RGB(0,255,0), 3, 8, 0 );
	if(persona.brazo1.size()>0 && persona.brazo2.size()>0){
		cuello_hombros[2]=persona.brazo1.back();//hombro lado izquierdo
		cuello_hombros[3]=persona.brazo2.back();//hombro lado derecho
		cuello_hombros[0]=cvPoint(persona.cabeza.x+(persona.cabeza.width / 2),persona.cabeza.y+persona.cabeza.height);//Cuello
		cuello_hombros[1]=cvPoint((cuello_hombros[2].x + cuello_hombros[3].x)/2, (cuello_hombros[2].y + cuello_hombros[3].y)/2);//Cuello
		
		persona.cuello.clear();
		persona.cuello.push_back(cuello_hombros[0]);
		persona.cuello.push_back(cuello_hombros[1]);
		persona.hombros.clear();
		persona.hombros.push_back(cuello_hombros[2]);
		persona.hombros.push_back(cuello_hombros[3]);
	}
	return cuello_hombros;
}

vector<CvPoint> AnalisisPersona::detectarColumnaVertebral(){
	vector<CvPoint> columnaVertebral;
	if(persona.cuello.size()>1){
		columnaVertebral.push_back(persona.cuello[1]);
		int x1=0, y1=0, x2=0, y2=0, pendiente=0;
		if(caso<5){
			if(persona.brazo1.size()>1 && persona.brazo2.size()>1){
				if(persona.brazo1Inf.size()>2 && persona.brazo2Inf.size()>2){
					x1 = (persona.brazo1Inf[2].x + persona.brazo2Inf[2].x)/2;
					y1 = (persona.brazo1Inf[2].y + persona.brazo2Inf[2].y)/2;
				}else if(persona.brazo1Inf.size()>2 && persona.brazo2Inf.size()<=2){
					x1 = (persona.brazo1Inf[2].x + persona.brazo2[0].x)/2;
					y1 = (persona.brazo1Inf[2].y + persona.brazo2[0].y)/2;
				}else if(persona.brazo1Inf.size()<=2 && persona.brazo2Inf.size()>2){
					x1 = (persona.brazo1[0].x + persona.brazo2Inf[2].x)/2;
					y1 = (persona.brazo1[0].y + persona.brazo2Inf[2].y)/2;
				}else if(persona.brazo1Inf.size()<=2 && persona.brazo2Inf.size()<=2){
					x1 = (persona.brazo1[0].x + persona.brazo2[0].x)/2;
					y1 = (persona.brazo1[0].y + persona.brazo2[0].y)/2;
				}

				columnaVertebral.push_back(cvPoint(x1,y1));

				//interpolamos para llegar hasta abajo
				y2=persona.max.y;
				pendiente = columnaVertebral.back().x - columnaVertebral[columnaVertebral.size()-2].x;
				if(columnaVertebral.back().y - columnaVertebral[columnaVertebral.size()-2].y !=0){
					pendiente=pendiente/(columnaVertebral.back().y - columnaVertebral[columnaVertebral.size()-2].y);
					x2=x1 + y2*pendiente;
					columnaVertebral.push_back(cvPoint(x2,y2));
				}
				if(columnaVertebral.back().x>persona.max.x || columnaVertebral.back().x<persona.min.x){//ultima comprobacion, si el punto se sale fuera del rango del area de la persona, entonces hay que descartarlo
					columnaVertebral.back().x=columnaVertebral[0].x;
				}
			}else{
				y1=persona.max.y;
				x1= columnaVertebral.back().x;
				columnaVertebral.push_back(cvPoint(x1,y1));
			}
		}else if(caso==5 || caso==8){
			double grosorMusculos = 0.2*(persona.max.x-persona.min.x);
			x1 =persona.PHI[0].puntos[persona.PHI[0].puntos.size()-1].x - grosorMusculos;
			y1 =persona.PHI[0].puntos[persona.PHI[0].puntos.size()-1].y;
			columnaVertebral.push_back(cvPoint(x1,y1));
		}else if(caso==6 || caso==7){
			double grosorMusculos = 0.2*(persona.max.x-persona.min.x);
			x1 =persona.PHD[0].puntos[persona.PHD[0].er.maxRel.back()].x + grosorMusculos;
			y1 =persona.PHD[0].puntos[persona.PHD[0].puntos.size()-1].y;
			columnaVertebral.push_back(cvPoint(x1,y1));
		}
	}


	return columnaVertebral;
}
CvRect AnalisisPersona::detectarCabeza(){
	int i, j, k;
	CvPoint pt1, pt2, dot;
	CvRect r;
	r.y = persona.min.y;
	r.x = persona.min.x;
	r.width = persona.max.x - persona.min.x;
	r.height = persona.max.y - persona.min.y;
	vector<int> indicesPuntoBarbilla;//candidatos de ser el punto de la barbilla
	vector<int> indicesPuntoBarbillaAux;//guarda el anterior punto mas proximo con derivada <=0//el ultimo valor es un dato temporal
	vector<int> grosoresPuntoBarbilla;//grosor asociado para cada valor del indicesPuntoBarbilla
	vector<int> indiceGrosoresPuntoBarbilla;//indice asociado al punto mas grueso
	vector<int> grosorPuntoBarbillaAux;//mayor grosor de la cabeza hasta el punto i-esimo, que tiene relacin con indicesPuuntosBarbillaAux
	vector<int> indiceGrosorPuntoBarbillaAux;//indice del punto que pertenece a grosorPuntoBarbillaAux
	grosoresPuntoBarbilla.push_back(0);
	indiceGrosoresPuntoBarbilla.push_back(0);
	
	int indicePuntoBarbilla=1;//el candidato elegido como punto de la barbilla
	int indicePuntoMasGruesoCabeza=1;

	vector<int> grosorCuerpo;
	vector<int> derivadaGrosorCuerpo;
	int prevGrosor=0;
	int minimo=min(persona.PHD[0].puntos.size(),persona.PHI[0].puntos.size());

	Esqueleto personaPrev1, personaPrev2;
	CvRect vectorDireccionCabeza = cvRect(0,0,0,0);//direccion del movimiento de la cabeza
	CvRect cabezaEstimada = cvRect(0,0,0,0);
	vector<CvRect> listaCandidatosCabeza;
	vector<double> resultadosCompeticionCabeza;
	if(HistoricoEsqueletos::getHistoricoEsqueletos()->size()>0){
		personaPrev1=HistoricoEsqueletos::getHistoricoEsqueletos()->back();
		if(HistoricoEsqueletos::getHistoricoEsqueletos()->size()>1){//si tenemos dos iteraciones anteriores con info de esqueletos
			personaPrev2 =HistoricoEsqueletos::getHistoricoEsqueletos()->element(HistoricoEsqueletos::getHistoricoEsqueletos()->size()-2);
			vectorDireccionCabeza.x = personaPrev1.getCabeza().x - personaPrev2.getCabeza().x;
			vectorDireccionCabeza.y = personaPrev1.getCabeza().y - personaPrev2.getCabeza().y;
			vectorDireccionCabeza.height = personaPrev1.getCabeza().height - personaPrev2.getCabeza().height;
			vectorDireccionCabeza.width = personaPrev1.getCabeza().width - personaPrev2.getCabeza().width;
			cabezaEstimada.x=vectorDireccionCabeza.x + personaPrev1.getCabeza().x;
			cabezaEstimada.y=vectorDireccionCabeza.y + personaPrev1.getCabeza().y;
			cabezaEstimada.height=vectorDireccionCabeza.height + personaPrev1.getCabeza().height;
			cabezaEstimada.width=vectorDireccionCabeza.width + personaPrev1.getCabeza().width;
		}
	}

	if(caso<5){
		//primero calculamos cuales van a ser los pivotes para el algoritmo iterativo que encontrara la cabeza
		CvPoint pivote1, pivote2, pivote0;
		if(persona.PVC[0].er.minRel.size()>1){
			pivote1=persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]];
			pivote2=persona.PVC[0].puntos[persona.PVC[0].er.minRel[1]];
		}else if (persona.PVC[0].er.minRel.size()==1){
			if(persona.PHD[0].er.maxRel[0]>persona.PHI[0].er.minRel[0]){
				pivote1=persona.PVC[0].puntos[0];
				pivote2=persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]];
			}else{
				pivote1=persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]];
				pivote2=persona.PVC[0].puntos[0];
			}
		}else if(persona.PVC[0].er.minRel.size()==0){
			pivote1=persona.PVC[0].puntos[0];
			pivote2=persona.PVC[0].puntos[persona.PVC[0].puntos.size()-1];
		}else{
			//error
		}

		if(persona.PVC[0].er.maxRel.size()==1 || persona.PVC[0].er.maxRel.size()==3){
			pivote0=persona.PVC[0].puntos[persona.PVC[0].er.maxRel[0]];
		}else{
			if(pivote1.x < persona.PVC[0].er.maxRel[0] && pivote2.x >persona.PVC[0].er.maxRel[0])
				pivote0=persona.PVC[0].puntos[persona.PVC[0].er.maxRel[0]];
			else
				pivote0=pivote0=persona.PVC[0].puntos[persona.PVC[0].er.maxRel[1]];
		}

		//aplicamos el algoritmo iterativo para localizar la cabeza
		int bandera=0;
		CvScalar s;
		while(bandera==0){
			//cvCircle( imgRetorno, pivote1, 3, CV_RGB(255,255,0), -1, 8,0);
			//cvCircle( imgRetorno, pivote2, 3, CV_RGB(255,255,0), -1, 8,0);
			int yEvaluacion = (pivote1.y + pivote2.y)/2;
			for(i=pivote1.x;i<pivote0.x;i++){
				s=cvGet2D(imgGray,(2*yEvaluacion + persona.min.y)/3,i);//obtenemos el valor del pixel columna, fila
				if(s.val[0]<220){
					break;
				}
			}
			for(j=pivote2.x;j>pivote0.x;j--){
				s=cvGet2D(imgGray,(yEvaluacion + persona.min.y)/2,j);//obtenemos el valor del pixel columna, fila
				if(s.val[0]<220){
					break;
				}
			}
			double proporcionAltoCabeza=0.0;
			proporcionAltoCabeza = (pivote2.x-pivote1.x)*1.35 / (persona.max.y - persona.min.y);
			if(((i-pivote1.x >18) || (pivote2.x-j >18)) &&(proporcionAltoCabeza>0.3) ){//seguir buscando
				pivote1.x=i;
				pivote2.x=j;
				if(i>persona.PVC[0].puntos[0].x){
					pivote1.y=persona.PVC[0].puntos[i - persona.PVC[0].puntos[0].x].y;
				}else{
					pivote1.y=persona.PVC[0].puntos[0].y;
				}
				pivote2.y=persona.PVC[0].puntos[j - persona.PVC[0].puntos[0].x].y;
			}else{//se encontro la cabeza
				/*for(i=i;i>pivote1.x;i--){
					s=cvGet2D(imgGray,(pivote1.y + persona.min.y)/2,i);//obtenemos el valor del pixel columna, fila
					if(s.val[0]>220){
						break;
					}
				}
				for(j=j;j<pivote2.x;j++){
					s=cvGet2D(imgGray,(pivote2.y + persona.min.y)/2,j);//obtenemos el valor del pixel columna, fila
					if(s.val[0]>220){
						break;
					}
				}
				pivote1.x=i;
				if(i>persona.PVC[0].puntos[0].x){
					pivote1.y=persona.PVC[0].puntos[i - persona.PVC[0].puntos[0].x].y;
				}else{
					pivote1.y=persona.PVC[0].puntos[0].y;
				}
				pivote2.x=j;
				pivote2.y=persona.PVC[0].puntos[j - persona.PVC[0].puntos[0].x].y;
				*/
				bandera=1;
			}
		}

		//cvCircle( imgRetorno, pivote1, 3, CV_RGB(255,0,0), -1, 8,0);
		//cvCircle( imgRetorno, pivote2, 3, CV_RGB(255,0,0), -1, 8,0);
		r=cvRect(pivote1.x,pivote0.y,pivote2.x-pivote1.x,(persona.max.y - persona.min.y)*0.33);
		double proporcionCara = 0.0 + r.width/r.height; 
		if(proporcionCara < 0.5){//si es un area muy alargada
			r.width=r.height*0.8;
		}

		//vector<int> proyeccionIzquierda, proyeccionDerecha;
		//ajustar la cabeza
		//for(i=r.y; i < (r.y + r.height*0.8); i++){//por la izquierda
		//	for(j=r.x - 10; j<(r.x + r.width);j++){
		//		s=cvGet2D(imgGray,i,j);
		//		if(s.val[0]<220){
		//			proyeccionIzquierda.push_back(j);
		//			break;
		//		}
		//	}
		//}
		//int w1=r.x + r.width;
		//for(i=0;i<proyeccionIzquierda.size();i++){
		//	if(w1>proyeccionIzquierda[i]){
		//		w1=proyeccionIzquierda[i];
		//	}
		//}
		//for(i=r.y; i < (r.y + r.height*0.8); i++){//por la derecha
		//	for(j=(r.x + r.width)+10;j<r.x;j++){
		//		s=cvGet2D(imgGray,i,j);
		//		if(s.val[0]<220){
		//			proyeccionDerecha.push_back(j);
		//			break;
		//		}
		//	}
		//}
		//int w2=r.x + r.width;
		//for(i=0;i<proyeccionDerecha.size();i++){
		//	if(w2<proyeccionDerecha[i]){
		//		w2=proyeccionDerecha[i];
		//	}
		//}
		//r=cvRect(w1,r.y,w2-w1,min(persona.PVC[0].puntos[w1-persona.min.x-1].y,persona.PVC[0].puntos[w2-persona.min.x-1].y)-r.height);		


		//r.y = persona.min.y;
		//r.x = persona.PHD[0].puntos[indiceGrosorPuntoBarbillaAux.back()].x;
		//r.width = grosorPuntoBarbillaAux.back();
		//r.height = indicesPuntoBarbillaAux.back();
	/*fin casos 1-4*/
	}else if(caso==5){
		CvPoint minHead =persona.max;
		CvPoint maxHead;
		int valY=0, valX=0;

		for(i=0;i<persona.PDI[0].er.minRel.size();i++){
			if((- persona.PDI[0].puntos[persona.PDI[0].er.minRel[i]].x + persona.PDI[0].puntos[persona.PDI[0].er.minRel[i]].y) < (-minHead.x+minHead.y))
			minHead  = persona.PDI[0].puntos[persona.PDI[0].er.minRel[i]];
		}

		if(persona.PVC[0].er.maxRel.size()==2){
			if(persona.PVC[0].er.minRel.size()>=1){//cerca del hombro
				valY=persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]].y;
				valX=persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]].x;
			}
			for(i=0;i<persona.PVC[0].er.maxRel.size();i++){
				int numeroAux=persona.PVC[0].puntos[persona.PVC[0].er.maxRel[i]].x;
				if(numeroAux<minHead.x && numeroAux>valX){//el maximo relativo es la parte mas alta de la cabeza
					minHead.y=persona.PVC[0].puntos[persona.PVC[0].er.maxRel[i]].y;
				}
			}
		}else{
			double coeficienteCabeza = 0.0;
			coeficienteCabeza = (persona.max.y - persona.min.y);
			valX=minHead.x - 0.15*coeficienteCabeza;
			valY=minHead.y + 0.3*coeficienteCabeza;
		}
		maxHead = cvPoint(minHead.x, valY);//ordenamos los datos
		minHead.x=valX;//ordenamos los datos
		
		r.y = minHead.y;
		r.x = minHead.x;
		r.width = maxHead.x - minHead.x;
		r.height = maxHead.y - minHead.y;
	/*fin caso 5*/
	}else if(caso==6){
		CvPoint minHead =persona.max;
		CvPoint maxHead;
		int valY=0, valX=0;

		for(i=0;i<persona.PDD[0].er.minRel.size();i++){
			if((persona.PDD[0].puntos[persona.PDD[0].er.minRel[i]].x + persona.PDD[0].puntos[persona.PDD[0].er.minRel[i]].y) < (minHead.x+minHead.y)){
				if( persona.PDD[0].puntos[persona.PDD[0].er.minRel[i]].x >persona.min.x &&  persona.PDD[0].puntos[persona.PDD[0].er.minRel[i]].y>persona.min.y){
					minHead  = persona.PDD[0].puntos[persona.PDD[0].er.minRel[i]];
				}
			}
		}

		if(persona.PVC[0].er.maxRel.size()==2){
			if(persona.PVC[0].er.minRel.size()==1){
				valY=persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]].y;
				valX=persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]].x;
			}else if(persona.PVC[0].er.minRel.size()==3){
				valY=persona.PVC[0].puntos[persona.PVC[0].er.minRel[1]].y;
				valX=persona.PVC[0].puntos[persona.PVC[0].er.minRel[1]].x;
			}else if(persona.PVC[0].er.minRel.size()==2){
				if(persona.PVC[0].er.minRel[0]<persona.PVC[0].er.maxRel[0]){
					valY=persona.PVC[0].puntos[persona.PVC[0].er.minRel[1]].y;
					valX=persona.PVC[0].puntos[persona.PVC[0].er.minRel[1]].x;
				}else{
					valY=persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]].y;
					valX=persona.PVC[0].puntos[persona.PVC[0].er.minRel[0]].x;
				}
			}

			for(i=0;i<persona.PVC[0].er.maxRel.size();i++){
				int numeroAux=persona.PVC[0].puntos[persona.PVC[0].er.maxRel[i]].x;
				if(numeroAux>minHead.x && numeroAux<valX){
					minHead.y=persona.PVC[0].puntos[persona.PVC[0].er.maxRel[i]].y;
				}
			}
		}else{ 
			double coeficienteCabeza = 0.0;
			coeficienteCabeza = (persona.max.y - persona.min.y);
			valX=minHead.x + 0.15*coeficienteCabeza;
			valY=minHead.y + 0.3*coeficienteCabeza;
		}
		maxHead = cvPoint(valX, valY);
		
		
		r.y = minHead.y;
		r.x = minHead.x;
		r.width = maxHead.x - minHead.x;
		r.height = maxHead.y - minHead.y;
	/*fin caso 6*/
	}else if(caso==7 || caso==8){
		double coeficienteCabeza = 0.0;
		coeficienteCabeza = persona.max.y - persona.min.y;
		CvPoint puntoMedio = cvPoint((persona.brazo1.back().x + persona.brazo2.back().x)/2, (persona.brazo1.back().y + persona.brazo2.back().y)/2);
		CvPoint minHead = cvPoint(puntoMedio.x - coeficienteCabeza*0.15,puntoMedio.y - coeficienteCabeza*0.33);
		CvPoint maxHead = cvPoint(puntoMedio.x + coeficienteCabeza*0.15,puntoMedio.y - coeficienteCabeza*0.06);
		
		r.y = minHead.y;
		r.x = minHead.x;
		r.width = maxHead.x - minHead.x;
		r.height = maxHead.y - minHead.y;
	/*fin if caso 7 - 8*/
	}




	/*pt1.x = r.x;
    pt2.x = (r.x+r.width);
    pt1.y = r.y;
    pt2.y = (r.y+r.height);
	
    // Draw the rectangle in the input image
    cvRectangle( imgRetorno, pt1, pt2, CV_RGB(255,0,0), 3, 8, 0 );*/
	return r;
}

void AnalisisPersona::volcarPersonaAEsqueleto(){
	esqueleto.setCabeza(persona.cabeza);
	esqueleto.setCuello(persona.cuello);
	esqueleto.setClavicula(persona.hombros);
	esqueleto.setTronco(persona.columnaVertebral);
	esqueleto.setBrazo1(persona.brazo1);
	esqueleto.setBrazo2(persona.brazo2);
	esqueleto.setCadera(persona.cadera);
	esqueleto.setPierna1(persona.pierna1);
	esqueleto.setPierna2(persona.pierna2);
}
CvRect AnalisisPersona::localizarCuerpo(vector<int> numeroPixelsNegrosFila, vector<int> numeroPixelsNegrosColumna, ExtremosRelativos erFilas, ExtremosRelativos erColumnas){
	int i, j;
	/*Los candidatos son las areas encerradas entre dos minimos (maximos relativos segn la convencion de la funcion que ofrece la funcion de calculos de extremos relativos)*/
	vector<int> puntosRelevantesColumnas;
	vector<int> puntosRelevantesFilas;
	double coeficienteRelevanciaInc = 0.0;
	CvPoint centro = cvPoint( numeroPixelsNegrosColumna.size()/2, numeroPixelsNegrosFila.size()/2);//centro geometrico del anterior cuerpo humano detectado; por defecto es el centro de la pantalla
	if(HistoricoEsqueletos::getHistoricoEsqueletos()->size()>0){
		centro.x=(personaPrev.min.x + personaPrev.max.x)/2;
		centro.y=(personaPrev.min.y + personaPrev.max.y)/2;
	}

	for(i=0; i<erColumnas.maxRel.size()-1; i++){
		int indiceMinRel=0;
		if(erColumnas.minRel[i]>erColumnas.maxRel[i] && erColumnas.minRel[i]<erColumnas.maxRel[i+1]){
			indiceMinRel=i;
		}else if(erColumnas.minRel[i+1]>erColumnas.maxRel[i] && erColumnas.minRel[i+1]<erColumnas.maxRel[i+1]){
			indiceMinRel=i+1;
		}
		coeficienteRelevanciaInc =  numeroPixelsNegrosColumna[erColumnas.maxRel[i]] + 0.1*( numeroPixelsNegrosColumna[erColumnas.minRel[indiceMinRel]]- numeroPixelsNegrosColumna[erColumnas.maxRel[i]]);
		for(j=erColumnas.maxRel[i];j<erColumnas.minRel[indiceMinRel];j++){
			if(numeroPixelsNegrosColumna[j]>coeficienteRelevanciaInc){
				puntosRelevantesColumnas.push_back(j);
				break;
			}
		}
		coeficienteRelevanciaInc = numeroPixelsNegrosColumna[erColumnas.maxRel[i+1]] + 0.1*( numeroPixelsNegrosColumna[erColumnas.minRel[indiceMinRel]]- numeroPixelsNegrosColumna[erColumnas.maxRel[i+1]]);
		for(j=erColumnas.maxRel[i+1];j>erColumnas.minRel[indiceMinRel];j--){
			if(numeroPixelsNegrosColumna[j]>coeficienteRelevanciaInc){
				puntosRelevantesColumnas.push_back(j);
				break;
			}
		}
	}
	for(i=0; i<erFilas.maxRel.size()-1; i++){
		int indiceMinRel=0;
		if(erFilas.minRel[i]>erFilas.maxRel[i] && erFilas.minRel[i]<erFilas.maxRel[i+1]){
			indiceMinRel=i;
		}else if(erFilas.minRel[i+1]>erFilas.maxRel[i] && erFilas.minRel[i+1]<erFilas.maxRel[i+1]){
			indiceMinRel=i+1;
		}
		coeficienteRelevanciaInc = numeroPixelsNegrosFila[erFilas.maxRel[i]] + 0.1*( numeroPixelsNegrosFila[erFilas.minRel[indiceMinRel]]- numeroPixelsNegrosFila[erFilas.maxRel[i]]);
		for(j=erFilas.maxRel[i];j<erFilas.minRel[indiceMinRel];j++){
			if(numeroPixelsNegrosFila[j]>coeficienteRelevanciaInc){
				puntosRelevantesFilas.push_back(j);
				break;
			}
		}
		coeficienteRelevanciaInc = numeroPixelsNegrosFila[erFilas.maxRel[i+1]] + 0.1*( numeroPixelsNegrosFila[erFilas.minRel[indiceMinRel]]- numeroPixelsNegrosFila[erFilas.maxRel[i+1]]);
		for(j=erFilas.maxRel[i+1];j>erFilas.minRel[indiceMinRel];j--){
			if(numeroPixelsNegrosFila[j]>coeficienteRelevanciaInc){
				puntosRelevantesFilas.push_back(j);
				break;
			}
		}
	}

	//for(i=0;i<puntosRelevantesColumnas.size();i++){//recorremos cada fila
	//	cvCircle( imgRetorno, cvPoint(puntosRelevantesColumnas[i], 10), 3, CV_RGB(255,255,0), -1, 8,0);
	//}
	//for(i=0;i<puntosRelevantesFilas.size();i++){//recorremos cada fila
	//	cvCircle( imgRetorno, cvPoint(10, puntosRelevantesFilas[i]), 3, CV_RGB(255,255,0), -1, 8,0);
	//}


	/*Seleccionar el candidato en el que se encuentra la persona de entre las diferentes regiones*/
	/*Primero en el eje vertical*/

	vector<int> candidatosFilas;
	for(i=0;i<puntosRelevantesFilas.size()-1;i+=2){//eliminamos aquellos que sean muy pequeos o tengan demasiados puntos en el eje horizontal
		int valor=puntosRelevantesFilas[i+1] - puntosRelevantesFilas[i];
		valor=valor*10;
		valor=valor/imgGray->height;
		candidatosFilas.push_back(valor);
	}
	for(i=0;i<puntosRelevantesFilas.size()-1;i+=2){//ponderamos mejor a los que estn mas centrados
		int valor =(puntosRelevantesFilas[i]+puntosRelevantesFilas[i+1])/2;
		valor-=centro.y;//imgGray->height/2;
		valor=abs(valor);
		if(HistoricoEsqueletos::getHistoricoEsqueletos()->size()>0){
		valor=(valor*20)/(centro.y);//(imgGray->height);
		}else{
		valor=(valor*6)/(centro.y);//(imgGray->height);
		}
		valor=10-valor;//asi cuanto mas cerca, mas puntos
		candidatosFilas[i/2]+=valor;
	}
	/*Luego en el eje horizontal*/
	vector<int> candidatosColumnas;
	for(i=0;i<puntosRelevantesColumnas.size()-1;i+=2){//eliminamos aquellos que sean muy pequeos o tengan demasiados puntos en el eje horizontal
		int valor = (puntosRelevantesColumnas[i+1]-puntosRelevantesColumnas[i])*100;
		valor = valor /imgGray->width;
		candidatosColumnas.push_back(valor);
	}

	/*Hacemos el conteo para saber cual ha sido el candidato electo*/
	int ganadorFilas=0;
	int ganadorColumnas=0;
	for(i=1;i<candidatosColumnas.size();i++){
		if(candidatosColumnas[i]>candidatosColumnas[ganadorColumnas]){
			ganadorColumnas=i;
		}
	}
	for(i=1;i<candidatosFilas.size();i++){
		if(candidatosFilas[i]>candidatosFilas[ganadorFilas] && suelo.y>=puntosRelevantesFilas[2*(i)+1]){
			ganadorFilas=i;
		}
	}
	
	CvPoint pt1, pt2;
	pt1.x = puntosRelevantesColumnas[2*ganadorColumnas];
    pt2.x = puntosRelevantesColumnas[2*ganadorColumnas+1];
    pt1.y = puntosRelevantesFilas[2*ganadorFilas];
    pt2.y = puntosRelevantesFilas[2*ganadorFilas+1];
	
	////ahora vamos a comprobar si se ha fragmentado el cuerpo en varias partes o no
	//if(ganadorFilas-1 >=0){//si hay un area encima
	//	double areaSignificativa =0.0;
	//	areaSignificativa += candidatosFilas[ganadorFilas -1];
	//	areaSignificativa= areaSignificativa/candidatosFilas[ganadorFilas];
	//	if(areaSignificativa<0.8){//y es suficientemente significativa
	//		pt1.y = puntosRelevantesFilas[2*(ganadorFilas-1)];
	//	}
	//}
	//if(ganadorFilas+1 < candidatosFilas.size()){//si hay un area por debajo
	//	double areaSignificativa =0.0;
	//	areaSignificativa += candidatosFilas[ganadorFilas +1];
	//	areaSignificativa= areaSignificativa/candidatosFilas[ganadorFilas];
	//	if(/*areaSignificativa<0.8 &&*/ suelo.y>=puntosRelevantesFilas[2*(ganadorFilas+1)+1]){//y es suficientemente significativa, estando por encima del suelo
	//		pt2.y = puntosRelevantesFilas[2*(ganadorFilas+1)+1];
	//	}
	//}
	//if(ganadorColumnas-1 >=0){//si hay un area encima
	//	double areaSignificativa =0.0;
	//	areaSignificativa += puntosRelevantesColumnas[2*(ganadorColumnas-1)] - puntosRelevantesColumnas[2*(ganadorColumnas-1)+1];;
	//	areaSignificativa = areaSignificativa/numeroPixelsNegrosColumna.size();
	//	if(fabs(areaSignificativa)<0.1){//y es suficientemente significativa
	//		pt1.x = puntosRelevantesColumnas[2*(ganadorColumnas-1)];
	//	}
	//}
	//if(ganadorColumnas+1 < candidatosColumnas.size()){//si hay un area por debajo
	//	double areaSignificativa =0.0;
	//	areaSignificativa += puntosRelevantesColumnas[2*(ganadorColumnas+1)] - puntosRelevantesColumnas[2*(ganadorColumnas+1)+1];;
	//	areaSignificativa= areaSignificativa/numeroPixelsNegrosColumna.size();
	//	if(fabs(areaSignificativa)<0.2){//y es suficientemente significativa, estando por encima del suelo
	//		pt2.x = puntosRelevantesColumnas[2*(ganadorColumnas+1)+1];
	//	}
	//}

	for(i=ganadorColumnas-1;i>=0;i--){
		double valorSignificativo=0.0;
		valorSignificativo+=puntosRelevantesColumnas[2*i +1]-pt1.x;
		valorSignificativo=fabs(valorSignificativo);
		valorSignificativo=valorSignificativo/numeroPixelsNegrosColumna.size();
		if(valorSignificativo<0.05){
			pt1.x=puntosRelevantesColumnas[2*i];
		}else{
			break;
		}
	}

	for(i=ganadorColumnas+1;i<candidatosColumnas.size();i++){
		double valorSignificativo=0.0;
		valorSignificativo+=puntosRelevantesColumnas[2*i]-pt2.x;
		valorSignificativo=fabs(valorSignificativo);
		valorSignificativo=valorSignificativo/numeroPixelsNegrosColumna.size();
		if(valorSignificativo<0.05){
			pt2.x=puntosRelevantesColumnas[2*i+1];
		}else{
			break;
		}
	}

	for(i=ganadorFilas-1;i>=0;i--){
		double valorSignificativo=0.0;
		valorSignificativo+=puntosRelevantesFilas[2*i +1]-pt1.y;
		valorSignificativo=fabs(valorSignificativo);
		valorSignificativo=valorSignificativo/numeroPixelsNegrosFila.size();
		if(valorSignificativo<0.05){
			pt1.y=puntosRelevantesFilas[2*i];
		}else{
			break;
		}
	}

	for(i=ganadorFilas+1;i<candidatosFilas.size();i++){
		double valorSignificativo=0.0;
		valorSignificativo+=puntosRelevantesFilas[2*i]-pt2.y;
		valorSignificativo=fabs(valorSignificativo);
		valorSignificativo=valorSignificativo/numeroPixelsNegrosFila.size();
		if(puntosRelevantesFilas[2*i+1]>suelo.y){
			break;
		}
		if(valorSignificativo<0.05){
			pt2.y=puntosRelevantesFilas[2*i+1];
		}else{
			break;
		}
	}

	if(pt1.x>10){
		pt1.x-=10;
	}
	if(pt1.y>10){
		pt1.y-=10;
	}
	if(pt2.x < imgGray->width - 10){
		pt1.x-=10;
	}
	if(pt2.y > imgGray->height - 10){
		pt1.y-=10;
	}
	/*pintar*/
//	cvRectangle( imgRetorno, pt1, pt2, CV_RGB(255,0,0), 3, 8, 0 );
	persona.min.x=pt1.x;
	persona.min.y=pt1.y;
	persona.max.x=pt2.x;
	persona.max.y=pt2.y;
	return cvRect(pt1.x, pt1.y, pt2.x-pt1.x, pt2.y-pt1.y);
}

CvRect AnalisisPersona::localizarSuelo(vector<int> numeroPixelsNegrosFila, vector<int> numeroPixelsNegrosColumna, ExtremosRelativos erFilas, ExtremosRelativos erColumnas){
	int i,j;
	int numeroFilas=numeroPixelsNegrosFila.size();
	int numeroColumnas=numeroPixelsNegrosColumna.size();
	int inicioBusquedaRegion = numeroFilas*0.7;//buscamos solo en el tercio inferior de la imagen
	vector<int> puntosRelevantesFilas;
	double coeficienteRelevanciaInc = 0.0;

	/*Primero afinamos donde empieza realmente*/
	for(i=0; i<erFilas.maxRel.size()-1; i++){
		int indiceMinRel=0;
		if(erFilas.minRel[i]>erFilas.maxRel[i] && erFilas.minRel[i]<erFilas.maxRel[i+1]){
			indiceMinRel=i;
		}else if(erFilas.minRel[i+1]>erFilas.maxRel[i] && erFilas.minRel[i+1]<erFilas.maxRel[i+1]){
			indiceMinRel=i+1;
		}
		coeficienteRelevanciaInc = numeroPixelsNegrosFila[erFilas.maxRel[i]] + 0.1*( numeroPixelsNegrosFila[erFilas.minRel[indiceMinRel]]- numeroPixelsNegrosFila[erFilas.maxRel[i]]);
		for(j=erFilas.maxRel[i];j<erFilas.minRel[indiceMinRel];j++){
			if(numeroPixelsNegrosFila[j]>coeficienteRelevanciaInc){
				puntosRelevantesFilas.push_back(j);
				break;
			}
		}
		coeficienteRelevanciaInc = numeroPixelsNegrosFila[erFilas.maxRel[i+1]] + 0.1*( numeroPixelsNegrosFila[erFilas.minRel[indiceMinRel]]- numeroPixelsNegrosFila[erFilas.maxRel[i+1]]);
		for(j=erFilas.maxRel[i+1];j>erFilas.minRel[indiceMinRel];j--){
			if(numeroPixelsNegrosFila[j]>coeficienteRelevanciaInc){
				puntosRelevantesFilas.push_back(j);
				break;
			}
		}
	}
	
	/*buscamos*/
	for(i=0; i<erFilas.minRel.size();i++){//en realidad minRel es un maximo relativo
		if(erFilas.minRel[i]>=inicioBusquedaRegion){
			double toleranciaPNegros = 0.0;
			toleranciaPNegros = 0.25 * numeroPixelsNegrosColumna.size();
/*comprobar*/if(numeroPixelsNegrosFila[erFilas.minRel[i]] > toleranciaPNegros){//el maximo relativo tiene al menos el 50% de puntos negros en esa fila
				int extremoInferiorY = i;
				if(i>0){
					if(erFilas.maxRel[i]>erFilas.minRel[i]){//estoy buscando el minimo relativo(maxRel) mas proximo a minRel[i]
						extremoInferiorY = i-1;
					}
					if(erFilas.maxRel.size()>extremoInferiorY*2){
						cvRectangle( imgRetorno, cvPoint(0, puntosRelevantesFilas[extremoInferiorY*2]), cvPoint(numeroPixelsNegrosColumna.size()-1,numeroPixelsNegrosFila.size()-1), CV_RGB(0,0,255), 3, 8, 0 );
						return cvRect(0,puntosRelevantesFilas[extremoInferiorY*2],numeroPixelsNegrosColumna.size()-1,numeroPixelsNegrosFila.size()- 1 - puntosRelevantesFilas[extremoInferiorY*2]);
					}else{
						cvRectangle( imgRetorno, cvPoint(0, erFilas.minRel.back()), cvPoint(numeroPixelsNegrosColumna.size()-1,numeroPixelsNegrosFila.size()-1), CV_RGB(0,0,255), 3, 8, 0 );
						return cvRect(0, erFilas.minRel.back(),numeroPixelsNegrosColumna.size()-1,numeroPixelsNegrosFila.size()- 1 - erFilas.minRel.back());
					}				
				}else{
/**/				cvRectangle( imgRetorno, cvPoint(0, erFilas.minRel[i]), cvPoint(numeroPixelsNegrosColumna.size()-1,numeroPixelsNegrosFila.size()-1), CV_RGB(0,0,255), 3, 8, 0 );
					return cvRect(0,erFilas.minRel[i],numeroPixelsNegrosColumna.size()-1,numeroPixelsNegrosFila.size()- 1 - erFilas.minRel[i]);
				}
			}
		}
	}
	//solucion por defecto
/**/	cvRectangle( imgRetorno, cvPoint(0, numeroPixelsNegrosFila.size()-2), cvPoint(numeroPixelsNegrosColumna.size()-1,numeroPixelsNegrosFila.size()-1), CV_RGB(255,0,0), 3, 8, 0 );
	return cvRect(0,numeroPixelsNegrosFila.size()-1,numeroPixelsNegrosColumna.size()-1,0);//por defecto el suelo es la ultima linea de abajo, o lo que es lo mismo, no se ha detectado
}
void AnalisisPersona::detectarCadera(){
	double coeficienteAnchoCadera= 0.18;
	if(persona.columnaVertebral.size()>0 &&persona.hombros.size()>1){
		CvPoint pt1=cvPoint(persona.columnaVertebral.back().x - coeficienteAnchoCadera*(persona.max.y-persona.min.y),persona.columnaVertebral.back().y), pt2=cvPoint(persona.columnaVertebral.back().x + coeficienteAnchoCadera*(persona.max.y-persona.min.y),persona.columnaVertebral.back().y);//calculamos la cadera en funcin del final de la columna vertebral y los hombros
		vector<CvPoint> v;
		v.push_back(pt1);
		v.push_back(pt2);
		persona.cadera=v;//asignamos la cadera
	}
}
void AnalisisPersona::detectarPiernas(){
	int i,j;
	vector<CvPoint> pierna1, pierna2;
	vector<CvPoint> proyeccionSuelo;//filtro de compas asociado a una region del suelo
	ExtremosRelativos erSuelo;//donde se almacenan los maximos y minimos relativos asociados al filtro de compas de la porcion del suelo
	CvSize tam =opciones->getTamImagen();
	CvPoint pt1, pt2, dot, pie1=cvPoint(0,0), pie2=cvPoint(0,0);
	CvScalar s;
	pt1= cvPoint(persona.min.x, suelo.y);
	pt2= cvPoint(persona.max.x, suelo.y+suelo.height);
	
	Esqueleto personaPrev1;
	if(HistoricoEsqueletos::getHistoricoEsqueletos()->size()>0){
		personaPrev1=HistoricoEsqueletos::getHistoricoEsqueletos()->back();
	}	

	//cvRectangle( imgRetorno, cvPoint(suelo.x, suelo.y), cvPoint(suelo.x + suelo.width, suelo.y + suelo.height), CV_RGB(0,255,0), 3, 8, 0 );
	if((suelo.y + 2 < tam.height) && persona.cadera.size()>1){//si el area del suelo es suficientemente grande
		//mapeamos el suelo
		for(j=pt1.x;j<pt2.x;j++){//recorremos cada columa de cada fila
			for(i=pt1.y;i<pt2.y;i++){//recorremos cada fila
				if(i>=tam.height){
					int tre=0;
				}
				if(j>=tam.width){
					int tre=0;
				}
				s=cvGet2D(imgGray,i,j);//obtenemos el valor del pixel fila i, columna j
				if(s.val[0]<220){
					dot.x=j;
					dot.y=i;
					//cvCircle( imgRetorno, dot, 3, CV_RGB(255,0,0), -1, 8,0);
					proyeccionSuelo.push_back(dot);
					break;
				}//fin if
			}//fin for
		}//fin for

		if(proyeccionSuelo.size()<10){//si no se ha sacado suficiente informacion del suelo
			if(persona.cadera.size()>1){
				pierna1.push_back(persona.cadera[0]);
				pierna1.push_back(cvPoint(persona.cadera[0].x, tam.height));
				pierna2.push_back(persona.cadera.back());
				pierna2.push_back(cvPoint(persona.cadera.back().x, tam.height));
				persona.pierna1=pierna1;
				persona.pierna2=pierna2;
			}
		}else{
			erSuelo=calcularExtremosRelativos(proyeccionSuelo, 0,5, 5,0);//queremos todos los extremos relativos
			
			for(i=0;i<erSuelo.minRel.size();i++){//recorremos cada fila
				cvCircle( imgRetorno, proyeccionSuelo[erSuelo.minRel[i]], 3, CV_RGB(255,255,0), -1, 8,0);
			}
			
			for(i=0;i<erSuelo.minRel.size();i++){//me quedo con los dos minimos relativos (los puntos mas bajos del suelo)
				if(proyeccionSuelo[erSuelo.minRel[i]].y>pie1.y){
					if(pie1.y>pie2.y){
						pie2=pie1;
					}
					pie1=proyeccionSuelo[erSuelo.minRel[i]];
				}
			}
			if(pie2.y==0){//si solo haba un minimo relativo
				pie2=pie1;
			}

			vector<CvPoint> candidatosPierna;
			for(i=0;i<erSuelo.minRel.size();i++){
				candidatosPierna.push_back(proyeccionSuelo[erSuelo.minRel[i]]);
			}
			CvPoint candidatoAux = pie1;
			//CvPoint candidatoP1 = personaPrev1.getPierna1().back(); 
			//CvPoint candidatoP2;
			int valor1=100000, valor2=100000;//valores suficientemente grandes	
			//competicion para obtener el mejor candidato para la pierna 1
			//valor2 = abs(candidatoAux.x - candidatoP1.x);
			//valor2 += abs(candidatoAux.y - candidatoP1.y);
			valor2 = abs(persona.cadera[0].x - candidatoAux.x);//para que los puntos estn lo mas centrados posibles
			valor2 += abs(suelo.y + 0.5*suelo.height - candidatoAux.y);
			//j=-1;
			for(i=0;i<candidatosPierna.size();i++){//elegimos el candidato mas proximo
				//valor1 = abs(candidatosPierna[i].x - candidatoP1.x);
				//valor1 += abs(candidatosPierna[i].y - candidatoP1.y);
				valor1 = abs(persona.cadera[0].x - candidatosPierna[i].x);//para que los puntos estn lo mas centrados posibles
				valor1 += abs(suelo.y + 0.5*suelo.height - candidatosPierna[i].y);
				if(abs(valor1) < abs(valor2)){
					candidatoAux=candidatosPierna[i];
					valor2=valor1;
					//j=i;
				}
			}
			pie1 = candidatoAux;//asignamos el candidato elegido
			//if(j>0){
			//	candidatosPierna.erase(candidatosPierna.begin()+j);//para que en la siguiente competicion no coja el mismo elemento
			//}

			//Competicion para la pierna2
			candidatoAux =  pie2;
			//candidatoP2 = personaPrev1.getPierna2().back();
			valor1=100000;
			valor2=100000;//valores suficientemente grandes
			//valor2 = abs(candidatoAux.x - candidatoP2.x);
			//valor2 += abs(candidatoAux.y - candidatoP2.y);
			valor2 = abs(persona.cadera.back().x - candidatoAux.x);//para que los puntos estn lo mas centrados posibles
			valor2 += abs(suelo.y + 0.5*suelo.height - candidatoAux.y);
			if(candidatosPierna.size()>0){//a veces el ejecutable da problemas con los for cuando la condicion de ruptura se cumple en la primera iteracion y se queda atascado en el bucle, aunque la condicion de ruptura se cumpla
				for(i=0;i<candidatosPierna.size();i++){//elegimos el candidato mas proximo
					//valor1 = abs(candidatosPierna[i].x - candidatoP2.x);
					//valor1 += abs(candidatosPierna[i].y - candidatoP2.y);
					valor1 = abs(persona.cadera.back().x - candidatosPierna[i].x);//para que los puntos estn lo mas centrados posibles
					valor1 += abs(suelo.y + 0.5*suelo.height - candidatosPierna[i].y);
					if(abs(valor1) < abs(valor2)){
						candidatoAux=candidatosPierna[i];
						valor2=valor1;
					}
				}
			}
			pie2 = candidatoAux;//asignamos el candidato elegido


			//calculamos ahora los vectores con las piernas
			if(persona.cadera.size()>1){
				pierna1.push_back(persona.cadera[0]);
				pierna1.push_back(pie1);
				pierna2.push_back(persona.cadera.back());
				pierna2.push_back(pie2);
				persona.pierna1=pierna1;
				persona.pierna2=pierna2;
			}
		}//fin if no se ha sacado suficiente informacion del suelo
	}else{
		if(persona.cadera.size()>1){
			pierna1.push_back(persona.cadera[0]);
			pierna1.push_back(cvPoint(persona.cadera[0].x, tam.height));
			pierna2.push_back(persona.cadera.back());
			pierna2.push_back(cvPoint(persona.cadera.back().x, tam.height));
			persona.pierna1=pierna1;
			persona.pierna2=pierna2;
		}
	}
}
void AnalisisPersona::finish()
{
}