/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Implementacion de AnalisisPersona.h
		Clase identifica donde est un cuerpo humano dentro de la escena e identifica sus partes
*/
#pragma once
#include "Algoritmo.h"
#include "HistoricoEsqueletos.h"
#include "OpcionesNegocio.h"
#include "Utilidades.h"
#include "MotorCasos.h"

#include "cv.h"
#include "highgui.h"
#include <stdio.h>
#include <ctype.h>
#include <iostream>

class AnalisisPersona:
	public Algoritmo
{
public:
	AnalisisPersona(void);
	~AnalisisPersona(void);
private:
	void hallarProyecciones(void);
	vector<CvPoint> detectarBrazos(void);
	CvRect detectarCabeza(void);
	vector<CvPoint> detectarCuello_HombrosConociendoCabeza(CvRect);
	vector<CvPoint> detectarColumnaVertebral(void);
	void volcarPersonaAEsqueleto(void);
	void dibujarCuerpoHumano(void);
	CvRect localizarSuelo(vector<int>, vector<int>, ExtremosRelativos, ExtremosRelativos);
	CvRect localizarCuerpo(vector<int>, vector<int>, ExtremosRelativos, ExtremosRelativos);
	void detectarCadera(void);
	void detectarPiernas(void);

public:
	IplImage* execute(IplImage*, int);
	void finish();

private:
	int caso, casoPrev, casoPrev2;//0=caso no definido, 1=posicin "firme", 2=brazo lado izquierdo levantado (por debajo de la cabeza), 3=brazo lado derecho levantado (por debajo de la cabeza), 4=los dos brazos levantados (por debajo de la cabeza), 
	//5=cruzamiento de brazos por el lado izquierdo
	//7=el brazo de la izquierda est tan levantado que coincide con la cabeza y el otro est separado del cuerpo (forma de L)
	//8=forma de L invertida
	IplImage* image, *imgGray, *imgGrayTemp, *imgRetorno;
	string nombreRuta;
	Algoritmo* filtro;
	OpcionesNegocio *opciones;

//	vector<int> asignacionERPV;//asignacion de extremos relativos a pv

	vector<ProyeccionLineaPuntos> listaPHDLPuntos;//lista con la proyeccion horizontal derecha de lineas de puntos
	vector<ProyeccionLineaPuntos> listaPVCLPuntos;//lista con la proyeccion vertical en caida de lineas de puntos
	vector<ProyeccionLineaPuntos> listaPHILPuntos;
	vector<ProyeccionLineaPuntos> listaPDDLPuntos;
	vector<ProyeccionLineaPuntos> listaPDILPuntos;
	vector<ProyeccionLineaPuntos> listaProyeccionesCuerpo;

	CvRect suelo;
	Persona persona, personaPrev;
	Esqueleto esqueleto;
};
