/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Pinta una imagen con el esqueleto o la mscara,
		en funcion de los parmetros de entrada
*/
#include "Dibujar.h"

IplImage *dibuja(IplImage* frame, IplImage* filtro, bool mascara, bool esqueleto){

	if(esqueleto==true){
		if(mascara==true){
			cvCopy(filtro, frame,0);
			return dibujaEsqueleto(frame);
		}else{
			return dibujaEsqueleto(frame);
		}
	}
	if(mascara==true){
		return filtro;
	}
	return frame;
}

IplImage *dibujaEsqueleto(IplImage* imgRetorno){
	int i;
	//cvRectangle( imgRetorno, persona.min, persona.max, CV_RGB(255,0,0), 3, 8, 0 );
	HistoricoEsqueletos *he = HistoricoEsqueletos::getHistoricoEsqueletos();
	Esqueleto persona = he->back();

	/*Dibujar cabeza*/
	CvPoint pt1, pt2;
	pt1.x = persona.getCabeza().x;
    pt2.x = (persona.getCabeza().x+persona.getCabeza().width);
    pt1.y = persona.getCabeza().y;
    pt2.y = (persona.getCabeza().y+persona.getCabeza().height);
	cvRectangle( imgRetorno, pt1, pt2, CV_RGB(0,255,0), 2/*delgadez*/, 8, 0 );

	/*Dibujar brazos*/
	if(persona.getBrazo1().size()>2){
		cvLine(imgRetorno,persona.getBrazo1()[0],persona.getBrazo1()[1], CV_RGB(0,255,0),2,8,0);//antebrazo izquierdo
		cvLine(imgRetorno,persona.getBrazo1()[3],persona.getBrazo1()[2], CV_RGB(0,255,0),2,8,0);//brazo izquierdo
	}
	if(persona.getBrazo2().size()>2){
		cvLine(imgRetorno,persona.getBrazo2()[0],persona.getBrazo2()[1], CV_RGB(0,255,0),2,8,0);//antebrazo izquierdo
		cvLine(imgRetorno,persona.getBrazo2()[3],persona.getBrazo2()[2], CV_RGB(0,255,0),2,8,0);//brazo izquierdo
	}
	/*Dibujar cuello*/
	if(persona.getCuello().size()>1){
		cvLine(imgRetorno,persona.getCuello()[0],persona.getCuello()[1], CV_RGB(0,255,0),3,8,0);//antebrazo izquierdo
	}
	/*Dibujar hombros*/
	if(persona.getClavicula().size()>1){
		cvLine(imgRetorno,persona.getClavicula()[0],persona.getClavicula()[1], CV_RGB(0,255,0),3,8,0);//antebrazo izquierdo
	}
	/*Dibujar columna*/
	if(persona.getTronco().size()>1){
		for(i=1;i<persona.getTronco().size();i++){
			cvLine(imgRetorno,persona.getTronco()[i-1],persona.getTronco()[i], CV_RGB(0,255,0),3,8,0);
		}
	}
	/*Dibujar cadera*/
	if(persona.getCadera().size()>1){
		for(i=1;i<persona.getCadera().size();i++){
			cvLine(imgRetorno,persona.getCadera()[i-1],persona.getCadera()[i], CV_RGB(0,255,0),3,8,0);
		}
	}
	/*Dibujar pierna1*/
	if(persona.getPierna1().size()>1){
		for(i=1;i<persona.getPierna1().size();i++){
			cvLine(imgRetorno,persona.getPierna1()[i-1],persona.getPierna1()[i], CV_RGB(0,255,0),2,8,0);
		}
	}
	/*Dibujar pierna2*/
	if(persona.getPierna2().size()>1){
		for(i=1;i<persona.getPierna2().size();i++){
			cvLine(imgRetorno,persona.getPierna2()[i-1],persona.getPierna2()[i], CV_RGB(0,255,0),2,8,0);
		}
	}
	return imgRetorno;
}