/*	
	Proyecto:
		PFC
	Ao:
		2011.
	Version:
		1.0
	Fecha de ultima modificacion:
		16-Abr-2011.
	Autor:
		Jose Luis Martinez Jimenez.
	Descripcion:
		Implementacion de FFloodFill.h
*/
#include "FFloodFill.h"

FFloodFill::FFloodFill(){}

FFloodFill::FFloodFill(FBorde *drIn)
{
	dr=drIn;

	ffill_case = 1;
	lo_diff = 60;
	up_diff = 60;
	connectivity = 4;
	is_color = 1;
	is_mask = 0;
	new_mask_val = 255;

	CvSize tam = OpcionesNegocio::getOpcionesNegocio()->getTamImagen();
	mask = cvCreateImage( cvSize(tam.width + 2, tam.height + 2), 8, 1 );
	mask2 = cvCreateImage( cvSize(tam.width + 2, tam.height + 2), 8, 1 );
	resultado = cvCreateImage( cvSize(tam.width, tam.height), 8, 1 );
	color_img = cvCreateImage( cvSize(tam.width, tam.height), 8, 3 );
	color_img0 = cvCreateImage( cvSize(tam.width, tam.height), 8, 3 );
	rAux=cvRect(0, 0, tam.width + 0, tam.height + 0);
	roid=&rAux;
	int z;
}

FFloodFill::~FFloodFill(void)
{
}

void FFloodFill::remarcarSeccion(int x, int y, IplImage* color_img, IplImage* mask)
{
    if( !color_img )
        return;

        CvPoint seed = cvPoint(x,y);
        int lo = ffill_case == 0 ? 0 : lo_diff;
        int up = ffill_case == 0 ? 0 : up_diff;
        int flags = connectivity + (new_mask_val << 8) +
                    (ffill_case == 1 ? CV_FLOODFILL_FIXED_RANGE : 0);
        //int b = rand() & 255, g = rand() & 255, r = rand() & 255;
        int b = 0, g=0, r=0;
		CvConnectedComp comp;

        if( is_mask )
            cvThreshold( mask, mask, 1, 128, CV_THRESH_BINARY );

        if( is_color )
        {
            CvScalar color = CV_RGB( r, g, b );
            cvFloodFill( color_img, seed, color, CV_RGB( lo, lo, lo ),
                         CV_RGB( up, up, up ), &comp, flags, is_mask ? mask : NULL );
            //cvShowImage( "image", color_img );
        }
        else
        {
            //CvScalar brightness = cvRealScalar((r*2 + g*7 + b + 5)/10);
            //cvFloodFill( gray_img, seed, brightness, cvRealScalar(lo),
            //             cvRealScalar(up), &comp, flags, is_mask ? mask : NULL );
            //cvShowImage( "image", gray_img );
        }

        //printf("%g pixels were repainted\n", comp.area );

        //if( is_mask )
            //cvShowImage( "mask", mask );
}


IplImage *FFloodFill::execute(IplImage *frame, int frameActual){


	color_img=dr->execute(frame,frameActual);	
	frameActual++;
	
	
	//cvCopyImage( frame, color_img );
/*	cvCopyImage( color_img, color_img0 );
	
	//gray_img0 = cvCreateImage( cvSize(color_img->width, color_img->height), 8, 1 );
	//cvCvtColor( color_img, gray_img0, CV_BGR2GRAY );
	//gray_img = cvCloneImage( gray_img0 );
	
	cvZero( mask );
	cvZero( mask2 );
	//cvShowImage( "mask", mask );
	is_mask = 1;

	remarcarSeccion(tamFrame.width/2, tamFrame.height - 30, color_img, mask2);
	//remarcarSeccion(color_img0->width/2 - 20, color_img0->height - 30, color_img, mask2);
	
	int xSec=tamFrame.width/2;
	remarcarSeccion(xSec, 30, color_img, mask);

	cvOr(mask, mask2, mask, 0);
	cvSetImageROI(mask,*roid);
	cvCopy(mask, resultado);

	
	//cvSetImageROI(mask2,*r);
	//cvNot(mask,mask);
	//cvAnd(frame,frame,color_img,mask);
*/
	cvCvtColor( color_img, resultado, CV_BGR2GRAY );
	cvThreshold(resultado, resultado, 10, 255, CV_THRESH_BINARY_INV );
	cvCvtColor( resultado, color_img, CV_GRAY2BGR );
	return color_img;
	

	//cvAnd(frame,frame,color_img,mask);
    //if( is_color )
        //return frame;
    //else
        //return gray_img;


}

void FFloodFill::finish(){}