/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Ventana principal del proyecto.
*/
#ifndef HEAD_TRACKER_H
#define HEAD_TRACKER_H

#include "ui_MainWindow.h"
#include "capturethread.h"
#include <QMainWindow>
#include <QDialog>
#include <QtGui\QMessageBox>
#include <QFileDialog>
#include <string>

#include "Ret.h"

class TrackController;
class RenderWidget;
class QToolBar;
class QDockWidget;
class SettingsWidget;
class Ret;
    
class MainWindow : public QMainWindow {
Q_OBJECT
public:
    MainWindow();
public slots:
	//void onFlipVerticalChanged(bool flip);
	void onResolutionSelected(CaptureThread::FrameSize newSize);
	void onPrevViewSelected(bool);
	void startTracking();
	void stopTracking();
	void pauseTracking();
	void openFile();
	void updateStats();
	void closeFile();
	void acercaDeAction();
protected:
	void closeEvent(QCloseEvent*);
private:
    Ui::MainWindow ui;
	TrackController* trackController;
	RenderWidget* renderWidget;
	QTimer* updateTimer;
	QToolBar* cameraToolbar;
	QDockWidget* settingsDock;
	SettingsWidget* settingsWidget;
	bool fileOpened;
};

#endif
