/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Fuente original:
		http://www.qtcentre.org/threads/11655-OpenCV-integration
	Modificacin:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Processingthead se encarga de coordinar el procesado
		de dicha imagen, es decir, de solicitar a la capa de
		Lgica (a travs de ControladorLogica) que procese 
		dicho frame y le retorne otro ya procesado. El frame 
		resultante es notificado al Filter dentro de un HeadState.
*/
#include "processingthread.h"
#include "headstate.h"
#include "filter.h"
#include "imagebuffer.h"
#include <QDebug>

#include<windows.h>

ProcessingThread::ProcessingThread(ImageBuffer* buffer) : QThread(), imageBuffer(buffer), rootFilter(0), flipVertical(false) {
	playing=true;
	isPauseProcessing=false;
	isStopProcessing=false;
	isPlayProcessing=true;
	currState = new HeadState();
	prevView=false;
}

void ProcessingThread::stop(){
	playing=false;
	isPlayProcessing=false;
}

void ProcessingThread::stopProcessing(){
	//playing=false;
	isStopProcessing=true;
}

void ProcessingThread::pauseProcessing(){
	playing=false;
	isPauseProcessing=true;
	isPlayProcessing=false;
}

void ProcessingThread::playProcessing(){
	if(isPauseProcessing==false){
		ControladorNegocio *controlador = ControladorNegocio::getControladorNegocio();
		controlador->stop();
		controlador->reset();
	}
	playing=true;
	isPauseProcessing=false;
	isPlayProcessing=true;
}

void ProcessingThread::toggleImage(){
	if(currentFrame) {
		IplImage* tmp = cvCreateImage( cvSize(currentFrame->width,currentFrame->height), 8, 3 );
		cvCopy(currentFrame,tmp,0);
		ControladorNegocio *controlador = ControladorNegocio::getControladorNegocio();
		currState->frame = controlador->getImage(tmp);
		if(rootFilter) {
			rootFilter->processPoint(currState);
		}
		cvReleaseImage(&tmp);
	}
}

void ProcessingThread::run() {
	ControladorNegocio *controlador = ControladorNegocio::getControladorNegocio();
	while(true) {
		int i=0;
		if(isPlayProcessing==true){
			currentFrame = imageBuffer->getFrame();
			IplImage* tmp = cvCreateImage( cvSize(currentFrame->width,currentFrame->height), 8, 3 );
			cvCopy(currentFrame,tmp,0);
			//qDebug() << "Processing thread has received a frame";
			if(currentFrame) {
				if(prevView==false){
					tmp=controlador->execute(tmp,i);
					i++;
				}else{
					Sleep(30);
				}
				if(flipVertical) {
					cvFlip(tmp, 0, 0);
				}
				currState->frame = tmp;
				
				if(rootFilter) {
				//	qDebug() << "about to notify the root listener of the frame";
					rootFilter->processPoint(currState);
				//	qDebug() << "done notification";
				}
				cvReleaseImage(&tmp);
			}else{
				int x;
				x=0;
			}
				/*if(isStopProcessing){
				ControladorNegocio *controlador = ControladorNegocio::getControladorNegocio();
				controlador->stop();
				playing=true;
				emit(videoEnds());
				isStopProcessing=false;
			}*/
		}else if(isPauseProcessing==false){//si se ha pulsado el boton de parar
			IplImage* currentFrame = imageBuffer->getFrame();
		}else{
			int x;
			x=0;
		}
	}
}


