/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Fuente original:
		http://www.qtcentre.org/threads/11655-OpenCV-integration
	Modificacin:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Ventana de configuracin que se incrusta en la ventana principal.
*/
#ifndef SETTINGS_H
#define SETTINGS_H

#include "ui_settings.h"
#include "capturethread.h"
#include "ControladorNegocio.h"
#include "trackController.h"
#include "Ret.h"

class SettingsWidget : public QWidget {
Q_OBJECT;
public:
	SettingsWidget(QWidget* parent = 0);
	void setPrevViewEnabled(bool enabled){ui.prevView->setEnabled(enabled);}
	void setTrackController(TrackController* tc){trackController=tc;}
public slots:
	void onPrevViewStateChanged(int state);
	void onMaskStateChanged(int state);
	void onSkeletonStateChanged(int state);
signals:
	void prevViewSelected(bool);
	//void maskChanged(bool);
	//void skeletonChanged(bool);
private:
	Ui::SettingsWidget ui;
	TrackController* trackController;
};

#endif
